Search results

Schedule

Represents the Schedule component that displays a list of events scheduled against specific date and timings, thus helping us to plan and manage it properly.

<div id="schedule"></div>
<script>
  var scheduleObj = new Schedule();
  scheduleObj.appendTo("#schedule");
</script>

Properties

agendaDaysCount

number

Sets the number of days to be displayed by default in Agenda View and in case of virtual scrolling, the number of days will be fetched on each scroll-end based on this count.

    <div id="Schedule"> </div>
import { Schedule, Agenda } from '@syncfusion/ej2-schedule';

Schedule.Inject(Agenda);

let scheduleObj: Schedule = new Schedule({
  views:['Agenda'],
  agendaDaysCount: 2
});
scheduleObj.appendTo('#Schedule');

Defaults to 7

allowClipboard

boolean

Enables clipboard functionality for appointments, allowing them to be copied using keyboard shortcuts and pasted onto the Scheduler. When set to true, users can use keyboard shortcuts to cut, copy appointments and paste them into different time slots or calendars.

Defaults to false

allowDragAndDrop

boolean

When set to true, allows the appointments to move over the time slots. When an appointment is dragged, both its start and end time tends to change simultaneously allowing it to reschedule the appointment on some other time.

Defaults to true

allowInline

boolean

This property helps user to add/edit the event in inline. By default, it is set to false.

Defaults to false

allowKeyboardInteraction

boolean

When set to true, allows the keyboard interaction to take place on Schedule.

Defaults to true

allowMultiCellSelection

boolean

This property helps user to allow/prevent the selection of multiple cells. By default, it is set to true.

Defaults to true

allowMultiDrag

boolean

This property helps to drag the multiple selected events. By default, it is set to false.

Defaults to false

allowMultiRowSelection

boolean

This property helps user to allow/prevent the selection of multiple days(rows). By default, it is set to true.

Defaults to true

allowResizing

boolean

When set to true, allows the resizing of appointments. It allows the rescheduling of appointments either by changing the start or end time by dragging the event resize handlers.

Defaults to true

allowSwiping

boolean

Defines whether to enable date navigations via swipe in touch devices or not.

Defaults to true

calendarMode

CalendarType

It allows the Scheduler to display in other calendar modes. By default, Scheduler is displayed in Gregorian calendar mode.

    <div id="Schedule"> </div>
import { Schedule, Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop } from '@syncfusion/ej2-schedule';

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop);

let scheduleObj: Schedule = new Schedule({
  calendarMode: "Islamic"
});
scheduleObj.appendTo("#Schedule");

To change the mode, you can set either Gregorian or Islamic as a value to this calendarMode property.

Defaults to ‘Gregorian’

cellHeaderTemplate

string | Function

It accepts either the string or HTMLElement as template design content and parse it appropriately before displaying it onto the month date cells. This template is only applicable for month view day cells.

    <div id="Schedule"> </div>
import {
  Schedule,
  Month,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-schedule";
import { Internationalization } from "@syncfusion/ej2-base";

Schedule.Inject(Month, Resize, DragAndDrop);

let instance: Internationalization = new Internationalization();
(window as TemplateFunction).getDate = (date: Date) => {
  return instance.formatDate(date, { skeleton: "Ed" });
};
interface TemplateFunction extends Window {
    getDate?: Function;
}
let scheduleObj: Schedule = new Schedule({
  views: ['Month'],
  cellHeaderTemplate: '<div class="templatewrap">${getDate(data.date)}</div>'
});
scheduleObj.appendTo("#Schedule");

Defaults to null

cellTemplate

string | Function

The template option which is used to render the customized work cells on the Schedule. Here, the template accepts either the string or HTMLElement as template design and then the parsed design is displayed onto the work cells. The fields accessible via template are as follows.

  • date: Returns the date of the cell.
  • groupIndex: Returns the group index of the cell.
  • type: Returns the type of the work cell. Refer to the below code snippet.
    <div id="Schedule"> </div>
import {
  Schedule,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop,
} from '@syncfusion/ej2-schedule';

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop);

(window as TemplateFunction).getMonthCellText = (date: Date) => {
  if (date.getDate() === 23) {
    return '<img src= "https://ej2.syncfusion.com/demos/src/schedule/images/birthday.svg" style="height:90%; width:90%" />';
  }
  return '';
};
(window as TemplateFunction).getWorkCellText = (date: Date) => {
  let weekEnds: number[] = [0, 6];
  if (weekEnds.indexOf(date.getDay()) >= 0) {
    return "<img src='https://ej2.syncfusion.com/demos/src/schedule/images/get-together.svg' style='height:90%; width:90%'/>";
  }
  return '';
};

interface TemplateFunction extends Window {
  getWorkCellText?: Function;
  getMonthCellText?: Function;
}

let scheduleObj: Schedule = new Schedule({
  cellTemplate:
    '${if(type === "workCells")}<div class="templatewrap">${getWorkCellText(data.date)}</div>${/if}${if(type === "monthCells")}<div class="templatewrap">${getMonthCellText(data.date)}</div>${/if}'
});
scheduleObj.appendTo('#Schedule');

Defaults to null

cssClass

string

It is used to customize the Schedule which accepts custom CSS class names that defines specific user-defined styles and themes to be applied on the Schedule element.

    <div id="Schedule"> </div>
import { Schedule, Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop } from '@syncfusion/ej2-schedule';

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop);

let scheduleObj: Schedule = new Schedule({
  cssClass: 'schedule-cell-dimension'
});
scheduleObj.appendTo("#Schedule");

Defaults to null

currentView

View

To set the active view on scheduler, the currentView property can be used and it usually accepts either of the following available view options. The view option specified in this property will be initially loaded on the schedule.

  • Day: Denotes Day view of the scheduler.
  • Week: Denotes Week view of the scheduler.
  • WorkWeek: Denotes Work Week view of the scheduler.
  • Month: Denotes Month view of the scheduler.
  • Year: Denotes Year view of the scheduler.
  • Agenda: Denotes Agenda view of the scheduler.
  • MonthAgenda: Denotes Month Agenda view of the scheduler.
  • TimelineDay: Denotes Timeline Day view of the scheduler.
  • TimelineWeek: Denotes Timeline Week view of the scheduler.
  • TimelineWorkWeek: Denotes Timeline Work Week view of the scheduler.
  • TimelineMonth: Denotes Timeline Month view of the scheduler.
  • TimelineYear: Denotes Timeline Year view of the scheduler.
    <div id="Schedule"> </div>
import { Schedule, Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop } from '@syncfusion/ej2-schedule';

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop);

let scheduleObj: Schedule = new Schedule({
  currentView:'Month'
});
scheduleObj.appendTo("#Schedule");

Defaults to ‘Week’

dateFormat

string

By default, Schedule follows the date-format as per the default culture assigned to it. It is also possible to manually set specific date format by using the dateFormat property.

    <div id="Schedule"> </div>
import { Schedule, Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop } from '@syncfusion/ej2-schedule';

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop);

let scheduleObj: Schedule = new Schedule({
  dateFormat:'dd-MMM-yyyy'
});
scheduleObj.appendTo("#Schedule");

The format of the date range label in the header bar depends on the dateFormat value or else based on the locale assigned to the Schedule.

Defaults to null

dateHeaderTemplate

string | Function

It accepts either the string or HTMLElement as template design content and parse it appropriately before displaying it onto the date header cells. The field that can be accessed via this template is date.

    <div id="Schedule"> </div>
import {
  Schedule,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-schedule";
import { Internationalization } from "@syncfusion/ej2-base";

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop);

let instance: Internationalization = new Internationalization();
(window as TemplateFunction).getDateHeaderText = (value: Date) => {
  return instance.formatDate(value, { skeleton: "Ed" });
};

interface TemplateFunction extends Window {
  getDateHeaderText?: Function;
}

let scheduleObj: Schedule = new Schedule({
  dateHeaderTemplate:
    '<div class="date-text">${getDateHeaderText(data.date)}</div>'
});
scheduleObj.appendTo("#Schedule");

Defaults to null

dateRangeTemplate

string | Function

It accepts either the string or HTMLElement as template design content and parse it appropriately before displaying it onto the header date range.

Defaults to null

dayHeaderTemplate

string | Function

It accepts either the string or HTMLElement as template design content and parse it appropriately before displaying it onto the day header cells. This template is only applicable for year view header cells.

Defaults to null

editorFooterTemplate

string | Function

The template option to render the customized footer of the editor window.

Defaults to null

editorHeaderTemplate

string | Function

The template option to render the customized header of the editor window.

Defaults to null

editorTemplate

string | Function

The template option to render the customized editor window. The form elements defined within this template should be accompanied with e-field class, so as to fetch and process it from internally.

    	<div id="Schedule"> </div>

		<script id="EventEditorTemplate" type="text/x-template">
			<table class="custom-event-editor" width="100%" cellpadding="5">
        <tbody>
            <tr>
                <td class="e-textlabel">Summary</td>
                <td colspan="4">
                    <input id="Subject" class="e-field e-input" type="text" value="" name="Subject" style="width: 100%" />
                </td>
            </tr>
            <tr>
                <td class="e-textlabel">Status</td>
                <td colspan="4">
                    <input type="text" id="EventType" name="EventType" class="e-field" style="width: 100%" />
                </td>
            </tr>
            <tr>
            <td class="e-textlabel">From</td>
                <td colspan="4">
                    <input id="StartTime" class="e-field" type="text" name="StartTime" />
                </td>
            </tr>
            <tr>
                <td class="e-textlabel">To</td>
                <td colspan="4">
                    <input id="EndTime" class="e-field" type="text" name="EndTime" />
                </td>
            </tr>
            <tr>
                <td class="e-textlabel">Reason</td>
                <td colspan="4">
                    <textarea id="Description" class="e-field e-input" name="Description" rows="3" cols="50"
                        style="width: 100%; height: 60px !important; resize: vertical"></textarea>
                </td>
            </tr>
        </tbody>
    </table>
</script>
import {
  Schedule,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop,
  PopupOpenEventArgs
} from "@syncfusion/ej2-schedule";
import { Internationalization } from "@syncfusion/ej2-base";
import { DateTimePicker } from "@syncfusion/ej2-calendars";
import { DropDownList } from "@syncfusion/ej2-dropdowns";

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop);

let scheduleObj: Schedule = new Schedule({
  editorTemplate: "#EventEditorTemplate",
  popupOpen: (args: PopupOpenEventArgs) => {
    if (args.type === "Editor") {
      let statusElement: HTMLInputElement = args.element.querySelector(
        "#EventType"
      ) as HTMLInputElement;
      if (!statusElement.classList.contains("e-dropdownlist")) {
        let dropDownListObject: DropDownList = new DropDownList({
          placeholder: "Choose status",
          value: statusElement.value,
          dataSource: ["New", "Requested", "Confirmed"]
        });
        dropDownListObject.appendTo(statusElement);
      }
      let startElement: HTMLInputElement = args.element.querySelector(
        "#StartTime"
      ) as HTMLInputElement;
      if (!startElement.classList.contains("e-datetimepicker")) {
        new DateTimePicker(
          { value: new Date(startElement.value) || new Date() },
          startElement
        );
      }
      let endElement: HTMLInputElement = args.element.querySelector(
        "#EndTime"
      ) as HTMLInputElement;
      if (!endElement.classList.contains("e-datetimepicker")) {
        new DateTimePicker(
          { value: new Date(endElement.value) || new Date() },
          endElement
        );
      }
    }
  }
});
scheduleObj.appendTo("#Schedule");

Defaults to null

enableAdaptiveUI

boolean

When set to true, the header view navigations are listed under the popup and if we enable resource grouping, the compact view will be enabled.

Defaults to false

enableAllDayScroll

boolean

When set to true, If valid, the scroll on the all day row is activated when the all day row height reaches the max height when the all day row is expanded.

Defaults to false

enableHtmlSanitizer

boolean

Specifies whether to enable the rendering of untrusted HTML values in the Schedule component. When this property is enabled, the component will sanitize any suspected untrusted strings and scripts before rendering them.

Defaults to true

enablePersistence

boolean

Enable or disable persisting component’s state between page reloads.

Defaults to false

enableRecurrenceValidation

boolean

The recurrence validation will be done by default. When this property is set to false, the recurrence validation will be skipped.

Defaults to true

enableRtl

boolean

Enable or disable rendering component in right to left direction.

Defaults to false

endHour

string

It is used to specify the end hour, at which the Schedule ends. It too accepts the time string in a short skeleton format.

    <div id="Schedule"> </div>
import { Schedule, Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop } from '@syncfusion/ej2-schedule';

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop);

let scheduleObj: Schedule = new Schedule({
  endHour: "18:00"
});
scheduleObj.appendTo("#Schedule");

Defaults to ‘24:00’

eventDragArea

string

It enables the external drag and drop support for appointments on scheduler, to be able to move them out of the scheduler layout. When the drag area is explicitly set with specific DOM element name, the appointments can be dragged anywhere within the specified drag area location.

    <div id="Schedule"> </div>
import { Schedule, Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop } from '@syncfusion/ej2-schedule';

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop);

let scheduleObj: Schedule = new Schedule({
  eventDragArea: "body"
});
scheduleObj.appendTo("#Schedule");

Defaults to null

eventSettings

EventSettingsModel

Complete set of settings related to Schedule events to bind it to local or remote dataSource, map applicable database fields and other validation to be carried out on the available fields.

    <div id="Schedule"> </div>
import {
  Schedule,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop,
} from "@syncfusion/ej2-schedule";

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop);

let data: object[] = [
  {
    Id:1,
    Subject: "Paris",
    StartTime: new Date(2023, 1, 15, 10, 0),
    EndTime: new Date(2023, 1, 15, 12, 30)
  }
];
let scheduleObj: Schedule = new Schedule({
  eventSettings: { dataSource: data }
});
scheduleObj.appendTo("#Schedule");

Defaults to null

firstDayOfWeek

number

This option allows the user to set the first day of a week on Schedule. It should be based on the locale set to it and each culture defines its own first day of week values. If needed, the user can set it manually on his own by defining the value through this property. It usually accepts the integer values, whereby 0 is always denoted as Sunday, 1 as Monday and so on.

    <div id="Schedule"> </div>
import { Schedule, Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop } from '@syncfusion/ej2-schedule';

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop);

let scheduleObj: Schedule = new Schedule({
  firstDayOfWeek: 2
});
scheduleObj.appendTo("#Schedule");

Defaults to 0

firstMonthOfYear

number

This property helps render the year view customized months. By default, it is set to 0.

<div id="Schedule"></div>
import { Schedule, TimelineYear, Year } from '@syncfusion/ej2-schedule';

Schedule.Inject(Year, TimelineYear);

let scheduleObj: Schedule = new Schedule({
  views: ['Year', 'TimelineYear'],
  firstMonthOfYear: 2
});
scheduleObj.appendTo("#Schedule");

Defaults to 0

group

GroupModel

Allows defining the group related settings of multiple resources. When this property is non-empty, it means that the resources will be grouped on the schedule layout based on the provided resource names.

    <div id="Schedule"> </div>
import {
  Schedule,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-schedule";

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop);

let scheduleObj: Schedule = new Schedule({
  group: {
    resources: ["Airlines"]
  },
  resources: [
    {
      field: "AirlineId",
      title: "Airline Name",
      name: "Airlines",
      allowMultiple: true,
      dataSource: [
        { AirlineName: "Airways 1", AirlineId: 1, AirlineColor: "#EA7A57" },
        { AirlineName: "Airways 2", AirlineId: 2, AirlineColor: "#357cd2" },
        { AirlineName: "Airways 3", AirlineId: 3, AirlineColor: "#7fa900" }
      ],
      textField: "AirlineName",
      idField: "AirlineId",
      colorField: "AirlineColor"
    }
  ]
});
scheduleObj.appendTo("#Schedule");

Defaults to {}

headerIndentTemplate

string | Function

Template option to customize the header indent bar. Here, the template accepts either the string or HTMLElement as template design and then the parsed design is displayed onto the header indent cell. Refer to the below code snippet.

    <div id="Schedule"> </div>

    <script id="indentTemplate" type="text/x-template">
        ${if (className == "e-header-cells")}
            <div class='template-wrap'>Template</div>
        ${/if}
    </script>
import {
  Schedule,
  Day,
  Week,
  WorkWeek,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-schedule";

Schedule.Inject(Day, Week, WorkWeek, Resize, DragAndDrop);

let scheduleObj: Schedule = new Schedule({
  headerIndentTemplate: "#indentTemplate",
});
scheduleObj.appendTo("#Schedule");

Defaults to null

headerRows

HeaderRowsModel[]

Allows defining the collection of custom header rows to display the year, month, week, date and hour label as an individual row on the timeline view of the scheduler.

    <div id="Schedule"> </div>
import { Schedule, TimelineViews } from "@syncfusion/ej2-schedule";

Schedule.Inject(TimelineViews);

let scheduleObj: Schedule = new Schedule({
  headerRows: [
    { option: "Year" },
    { option: "Month" },
    { option: "Week" },
    { option: "Date" },
    { option: "Hour" }
  ],
  views: ["TimelineWeek"]
});
scheduleObj.appendTo("#Schedule");

Defaults to []

height

string | number

Sets the height of the Schedule component, accepting both string and number values.

    <div id="Schedule"> </div>
import {
  Schedule,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda
} from "@syncfusion/ej2-schedule";

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda);

let scheduleObj: Schedule = new Schedule({
  height: "550px"
});
scheduleObj.appendTo("#Schedule");

The string type includes either pixel or percentage values. When height is set with specific pixel value, then the Schedule will be rendered to that specified space. In case, if auto value is set, then the height of the Schedule gets auto-adjusted within the given container.

Defaults to ‘auto’

hideEmptyAgendaDays

boolean

The days which does not has even a single event to display will be hidden from the UI of Agenda View by default. When this property is set to false, the empty dates will also be displayed on the Schedule.

Defaults to true

locale

string

Overrides the global culture and localization value for this component. Default global culture is ‘en-US’.

Defaults to

maxDate

Date

To define the maximum date on the Schedule, maxDate property can be defined. Usually, it defaults to the new Date(2099, 11, 31).

    <div id="Schedule"> </div>
import { Schedule, Day, Week, WorkWeek, Month, Agenda } from '@syncfusion/ej2-schedule';

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda);

let scheduleObj: Schedule = new Schedule({
  maxDate: new Date(2025, 1, 1)
});
scheduleObj.appendTo("#Schedule");

Defaults to new Date(2099, 11, 31)

minDate

Date

To define the minimum date on the Schedule, minDate property can be defined. Usually, it defaults to the new Date(1900, 0, 1).

    <div id="Schedule"> </div>
import { Schedule, Day, Week, WorkWeek, Month, Agenda } from '@syncfusion/ej2-schedule';

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda);

let scheduleObj: Schedule = new Schedule({
  minDate: new Date(2020, 1, 1)
});
scheduleObj.appendTo("#Schedule");

Defaults to new Date(1900, 0, 1)

monthHeaderTemplate

string | Function

It accepts either the string or HTMLElement as template design content and parse it appropriately before displaying it onto the month header cells. This template is only applicable for year view header cells.

Defaults to null

monthsCount

number

This option allows the user to set the number of months count to be displayed on the Schedule.

    <div id="Schedule"> </div>
import { Schedule, Year, TimelineYear } from '@syncfusion/ej2-schedule';

Schedule.Inject(Year, TimelineYear);

let scheduleObj: Schedule = new Schedule({
  views: ['TimelineYear', `Year`],
  monthsCount: 16
});
scheduleObj.appendTo('#Schedule');

Defaults to 12

quickInfoOnSelectionEnd

boolean

This property helps to show quick popup after multiple cell selection. By default, it is set to false.

Defaults to false

quickInfoTemplates

QuickInfoTemplatesModel

The template option to customize the quick window. The three sections of the quick popup whereas the header, content, and footer can be easily customized with individual template option.

    <div id="Schedule"> </div>

    <script id="headerTemplate" type="text/x-template">
        <div>
            ${if (elementType === 'cell')}
            <div class="e-cell-header">
                <div class="e-header-icon-wrapper">
                    <button class="e-close" title="Close"></button>
                </div>
            </div>
            ${else}
            <div class="e-event-header">
                <div class="e-header-icon-wrapper">
                    <button class="e-close" title="CLOSE"></button>
                </div>
            </div>
            ${/if}
        </div>
    </script>
    <script id="contentTemplate" type="text/x-template">
        <div>
            ${if (elementType === 'cell')}
            <div class="e-cell-content">
                <form class="e-schedule-form">
                    <div>
                        <input class="subject e-field" type="text" name="Subject" placeholder="Title">
                    </div>
                    <div>
                        <input class="location e-field" type="text" name="Location" placeholder="Location">
                    </div>
                </form>
            </div>
            ${else}
            <div class="e-event-content">
                <div class="e-subject-wrap">
                    ${if (Subject)}
                    <div class="subject">${Subject}</div>${/if} ${if (City)}
                    <div class="location">${City}</div>${/if} ${if (Description)}
                    <div class="description">${Description}</div>${/if}
                </div>
            </div>
            ${/if}
        </div>
    </script>
    <script id="footerTemplate" type="text/x-template">
        <div>
            ${if (elementType === 'cell')}
            <div class="e-cell-footer">
                <button class="e-event-details" title="Additional Details">Additional Details</button>
                <button class="e-event-create" title="Add">Add</button>
            </div>
            ${else}
            <div class="e-event-footer">
                <button class="e-event-edit" title="Edit">Edit</button>
                <button class="e-event-delete" title="Delete">Delete</button>
            </div>
            ${/if}
        </div>
    </script>
import {
  Schedule,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda
} from "@syncfusion/ej2-schedule";

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda);

let scheduleObj: Schedule = new Schedule({
  quickInfoTemplates: {
    header: "#headerTemplate",
    content: "#contentTemplate",
    footer: "#footerTemplate"
  }
});
scheduleObj.appendTo("#Schedule");

Defaults to null

readonly

boolean

When set to true, makes the Schedule to render in a read only mode. No CRUD actions will be allowed at this time.

Defaults to false

resourceHeaderTemplate

string | Function

Template option to customize the resource header bar. Here, the template accepts either the string or HTMLElement as template design and then the parsed design is displayed onto the resource header cells. The following can be accessible via template.

  • resource - All the resource fields.
  • resourceData - Object collection of current resource. Refer to the below code snippet.
    <div id="Schedule"> </div>

    <script id="resourceTemplate" type="text/x-template">
        <div class='template-wrap'>
            <div class="resource-details">
                <div class="resource-name">${resourceData.text}</div>
                <div class="resource-designation">${resourceData.designation}</div>
            </div>
        </div>
    </script>
import {
  Schedule,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from '@syncfusion/ej2-schedule';

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop);

let scheduleObj: Schedule = new Schedule({
  resourceHeaderTemplate: '#resourceTemplate',
  group: {
    resources: ['Employees']
  },
  resources: [
    {
      field: 'EmpId',
      title: 'Employee',
      name: 'Employees',
      allowMultiple: true,
      dataSource: [
        { text: 'Nancy', id: 1, color: '#df5286', designation:'PO' },
        { text: 'Steven', id: 2, color: '#7fa900', designation:'Manager' },
        { text: 'Robert', id: 3, color: '#ea7a57', designation:'Team Lead' },
      ],
      textField: 'text',
      idField: 'id',
      groupIDField: 'groupId',
      colorField: 'color'
    },
  ],
});
scheduleObj.appendTo('#Schedule');

Defaults to null

resources

ResourcesModel[]

Allows defining the collection of resources to be displayed on the Schedule. The resource collection needs to be defined with unique resource names to identify it along with the respective dataSource and field mapping options.

    <div id="Schedule"> </div>
import {
  Schedule,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-schedule";

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop);

let scheduleObj: Schedule = new Schedule({
  group: {
    resources: ["Airlines"]
  },
  resources: [
    {
      field: "AirlineId",
      title: "Airline Name",
      name: "Airlines",
      allowMultiple: true,
      dataSource: [
        { AirlineName: "Airways 1", AirlineId: 1, AirlineColor: "#EA7A57" },
        { AirlineName: "Airways 2", AirlineId: 2, AirlineColor: "#357cd2" },
        { AirlineName: "Airways 3", AirlineId: 3, AirlineColor: "#7fa900" }
      ],
      textField: "AirlineName",
      idField: "AirlineId",
      colorField: "AirlineColor"
    }
  ]
});
scheduleObj.appendTo("#Schedule");

Defaults to []

rowAutoHeight

boolean

when set to true, allows the height of the work-cells to adjust automatically based on the number of appointments present in those time ranges.

Defaults to false

selectedDate

Date

To mark the active (current) date on the Schedule, selectedDate property can be defined. Usually, it defaults to the current System date.

    <div id="Schedule"> </div>
import {
  Schedule,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda
} from "@syncfusion/ej2-schedule";

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda);

let scheduleObj: Schedule = new Schedule({
  selectedDate: new Date(2018, 3, 1)
});
scheduleObj.appendTo("#Schedule");

Defaults to ‘new Date()’

showHeaderBar

boolean

When set to false, hides the header bar of the Schedule from UI. By default, the header bar holds the date and view navigation options, to which the user can add their own custom items onto it.

Defaults to true

showQuickInfo

boolean

When set to true, displays a quick popup with cell or event details on single clicking over the cells or on events. By default, it is set to true.

Defaults to true

showTimeIndicator

boolean

When set to false, hides the current time indicator from the Schedule. Otherwise, it visually depicts the live current system time appropriately on the user interface.

Defaults to true

showWeekNumber

boolean

When set to true, displays the week number of the current view date range. By default, it is set to false.

Defaults to false

showWeekend

boolean

When set to false, it hides the weekend days of a week from the Schedule. The days which are not defined in the working days collection are usually treated as weekend days. Note: By default, this option is not applicable on Work Week view. For example, if the working days are defined as [1, 2, 3, 4], then the remaining days of that week will be considered as the weekend days and will be hidden on all the views.

Defaults to true

startHour

string

It is used to specify the starting hour, from which the Schedule starts to display. It accepts the time string in a short skeleton format and also, hides the time beyond the specified start time.

    <div id="Schedule"> </div>
import {
  Schedule,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda
} from "@syncfusion/ej2-schedule";

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda);

let scheduleObj: Schedule = new Schedule({
  startHour: "10:00"
});
scheduleObj.appendTo("#Schedule");

Defaults to ‘00:00’

timeFormat

string

By default, Schedule follows the time-format as per the default culture assigned to it. It is also possible to manually set specific time format by using the timeFormat property.

Defaults to null

timeScale

TimeScaleModel

Allows to set different time duration on Schedule along with the customized grid count. It also has template option to customize the time slots with required time values in its own format.

    <div id="Schedule"> </div>
import {
  Schedule,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda
} from "@syncfusion/ej2-schedule";

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda);

let scheduleObj: Schedule = new Schedule({
  timeScale: {
    enable: true,
    interval: 60,
    slotCount: 6
  }
});
scheduleObj.appendTo("#Schedule");

Defaults to { enable: true, interval: 60, slotCount: 2, majorSlotTemplate: null, minorSlotTemplate: null }

timezone

string

Schedule will be assigned with specific timezone, so as to display the events in it accordingly. By default, Schedule dates are processed with System timezone, as no timezone will be assigned specifically to the Schedule at the initial time. Whenever the Schedule is bound to remote data services, it is always recommended to set specific timezone to Schedule to make the events on it to display on the same time irrespective of the system timezone. It usually accepts the valid IANA timezone names.

    <div id="Schedule"> </div>
import {
  Schedule,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda
} from "@syncfusion/ej2-schedule";

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda);

let scheduleObj: Schedule = new Schedule({
  timezone: "UTC"
});
scheduleObj.appendTo("#Schedule");

Defaults to null

timezoneDataSource

TimezoneFields[]

Allows to define the collection of timezone items in the Schedule. Only the items bound to this property get listed out in the timezone dropdown of the appointment window.

    <div id="Schedule"> </div>
import { Schedule, Day, Week, WorkWeek, Month, Agenda } from '@syncfusion/ej2-schedule';

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda);

let scheduleObj: Schedule = new Schedule({
  timezoneDataSource: [
        { Value: 'Pacific/Niue', Text: 'Niue' },
        { Value: 'Pacific/Pago_Pago', Text: 'Pago Pago' },
        { Value: 'Pacific/Honolulu', Text: 'Hawaii Time' },
        { Value: 'Pacific/Rarotonga', Text: 'Rarotonga' },
        { Value: 'Pacific/Tahiti', Text: 'Tahiti' }
    ]
});
scheduleObj.appendTo("#Schedule");

Defaults to timezoneData

toolbarItems

ToolbarItemModel[]

To render the custom toolbar items, the toolbarItems property can be used. It contains built-in and custom toolbar items. To avail the built-in toolbar items, the below string values are assigned to the name property of the ToolbarItemModel.

  • Previous: Schedule component navigates to the previous date from the current date.
  • Next: Schedule component navigates to the next date from the current date.
  • Today: Schedule component navigates to the current date from any date.
  • Views: Schedule component render the defined view options in the toolbar. If view option is not defined, then it will render default view options in the Schedule.
  • DateRangeText: Schedule component displays the current date text range.
  • NewEvent: Schedule component render the icon to add a new event.

Defaults to []

views

View[] | ViewsModel[]

This property holds the views collection and its configurations. It accepts either the array of view names or the array of view objects that holds different configurations for each views. By default, Schedule displays all the views namely Day, Week, Work Week, Month and Agenda. Example for array of views:

Example for array of view objects:

Defaults to ’[“Day”, “Week”, “WorkWeek”, “Month”, “Agenda”]’

weekRule

WeekRule

It allows the Scheduler to display week numbers based on following available week options. The week option specified in this property will be initially loaded on the schedule.

  • FirstDay: Denotes that the first week of the year starts on the first day of the year and ends before the following designated first day of the week.
  • FirstFourDayWeek:Denotes that the first week of the year is the first week with four or more days before the designated first day of the week.
  • FirstFullWeek: Denotes that the first week of the year begins on the first occurrence of the designated first day of the week on or after the first day of the year.
    <div id="Schedule"> </div>
import { Schedule, Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop, DragEventArgs } from '@syncfusion/ej2-schedule';

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop);

let scheduleObj: Schedule = new Schedule({
  showWeekNumber: true,
  weekRule: 'FirstFourDayWeek'
});
scheduleObj.appendTo("#Schedule");

Defaults to ‘FirstDay’

width

string | number

Sets the width of the Schedule component, accepting both string and number values.

    <div id="Schedule"> </div>
import {
  Schedule,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda
} from "@syncfusion/ej2-schedule";

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda);

let scheduleObj: Schedule = new Schedule({
  width: '100%'
});
scheduleObj.appendTo("#Schedule");

The string value can be either pixel or percentage format. When set to auto, the Schedule width gets auto-adjusted and display its content related to the viewable screen size.

Defaults to ‘auto’

workDays

number[]

It is used to set the working days on Schedule. The only days that are defined in this collection will be rendered on the workWeek view whereas on other views, it will display all the usual days and simply highlights the working days with different shade.

    <div id="Schedule"> </div>
import {
  Schedule,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda
} from "@syncfusion/ej2-schedule";

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda);

let scheduleObj: Schedule = new Schedule({
  workDays: [1, 3, 5]
});
scheduleObj.appendTo("#Schedule");

Defaults to ’[1, 2, 3, 4, 5]’

workHours

WorkHoursModel

The working hours should be highlighted on Schedule with different color shade and an additional option must be provided to highlight it or not. This functionality is handled through workHours property and the start work hour should be 9 AM by default and end work hour should point to 6 PM. The start and end working hours needs to be provided as Time value of short skeleton type.

    <div id="Schedule"> </div>
import {
  Schedule,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda
} from "@syncfusion/ej2-schedule";

Schedule.Inject(Day, Week, WorkWeek, Month, Agenda);

let scheduleObj: Schedule = new Schedule({
  workHours: {
    highlight: true,
    start: "11:00",
    end: "20:00"
  }
});
scheduleObj.appendTo("#Schedule");

Defaults to { highlight: true, start: ‘09:00’, end: ‘18:00’ }

Methods

addEvent

Adds the newly created event into the Schedule dataSource.

Parameter Type Description
data Record | Record[] Single or collection of event objects to be added into Schedule.

Returns void

addEventListener

Adds the handler to the given event listener.

Parameter Type Description
eventName string A String that specifies the name of the event
handler Function Specifies the call to run when the event occurs.

Returns void

addResource

Adds the resources to the specified index.

Parameter Type Description
resources Record | Record[] Accepts the resource data in single or collection of data.
name string Name of the resource defined in resources collection.
index number Index or position where the resource should be added.

Returns void

appendTo

Appends the control within the given HTML element

Parameter Type Description
selector (optional) string | HTMLElement Target element where control needs to be appended

Returns void

attachUnloadEvent

Adding unload event to persist data when enable persistence true

Returns void

changeCurrentView

Current View could be change based on the provided parameters.

Parameter Type Description
viewName View Accept the view in the viewCollections.
viewIndex (optional) number Accept the viewIndex in the viewCollections.

Returns void

closeEditor

To manually close the event editor window

Returns void

closeQuickInfoPopup

To manually close the quick info popup

Returns void

closeTooltip

Closes the tooltip. For example, when the context menu is opened for an event, the tooltip can be closed by calling this method.

Returns void

collapseResource

This method allows to collapse the resource that available on the scheduler.

Parameter Type Description
resourceId string | number Accepts the resource id in either string or number type
name string Accepts the name of the resource collection

Returns void

copy

Method to copy events from an HTMLElement or an array of HTMLElements.

Parameter Type Description
elements HTMLElement[] Accepts an array of HTMLElement

Returns void

cut

Method to cut events from an HTMLElement or an array of HTMLElements.

Parameter Type Description
elements HTMLElement[] Accepts an array of HTMLElement

Returns void

dataBind

When invoked, applies the pending property changes immediately to the component.

Returns void

deleteEvent

Deletes the events based on the provided ID or event collection in the argument list.

Parameter Type Description
id string | number | Record | Record[] Accepts the ID as string or number type or single or collection of the event object which needs to be removed from the Schedule.
currentAction (optional) CurrentAction Denotes the delete action that takes place either on occurrence or series events.
The valid current action names are Delete, DeleteOccurrence or DeleteSeries.

Returns void

destroy

Destroys the Schedule component.

Returns void

detachUnloadEvent

Removing unload event to persist data when enable persistence true

Returns void

expandResource

This method allows to expand the resource that available on the scheduler.

Parameter Type Description
resourceId string | number Accepts the resource id in either string or number type
name string Accepts the name of the resource collection

Returns void

exportToExcel

Allows the Scheduler events data to be exported as an Excel file either in .xlsx or .csv file formats. By default, the whole event collection bound to the Scheduler gets exported as an Excel file. To export only the specific events of Scheduler, you need to pass the custom data collection as a parameter to this exportToExcel method. This method accepts the export options as arguments such as fileName, exportType, fields, customData, and includeOccurrences. The fileName denotes the name to be given for the exported file and the exportType allows you to set the format of an Excel file to be exported either as .xlsx or .csv. The custom or specific field collection of event dataSource to be exported can be provided through fields option and the custom data collection can be exported by passing them through the customData option. There also exists option to export each individual instances of the recurring events to an Excel file, by setting true or false to the includeOccurrences option, denoting either to include or exclude the occurrences as separate instances on an exported Excel file.

Parameter Type Description
excelExportOptions (optional) ExportOptions The export options to be set before start with exporting the Scheduler events to an Excel file.

Returns void

exportToICalendar

Exports the Scheduler events to a calendar (.ics) file. By default, the calendar is exported with a file name Calendar.ics. To change this file name on export, pass the custom string value as fileName to get the file downloaded with this provided name.

Parameter Type Description
fileName (optional) string Accepts the string value.
customData (optional) Record[] Accepts the collection of objects.

Returns void

generateEventOccurrences

Generates the occurrences of a single recurrence event based on the provided event.

Parameter Type Description
event Record Accepts the parent recurrence event from which the occurrences are generated.
startDate (optional) Date Accepts the start date for the event occurrences. If not provided, the event’s start date will be used.

Returns Record[]

getBlockEvents

Retrieves the entire collection of block events bound to the Schedule.

Parameter Type Description
startDate (optional) Date Accepts the start date.
endDate (optional) Date Accepts te end date.
includeOccurrences (optional) boolean Accepts the boolean value to process the occurrence from recurrence series.

Returns Record[]

getCellDetails

Retrieves the start and end time information of the specific cell element.

Parameter Type Description
tdCol Element | Element[] Accepts the single or collection of elements.

Returns CellClickEventArgs

getCurrentViewDates

Retrieves the dates that lies on active view of Schedule.

Returns Date[]

getCurrentViewEvents

Retrieves the events that lies on the current date range of the active view of Schedule.

Returns Record[]

getCurrentViewIndex

Return the current view Index.

Returns number

getDateRangeText

Retrieves a formatted string representing the date range of the given date collection.

Parameter Type Description
dates Date[] An array of Date objects representing the date range.

Returns string

getDeletedOccurrences

Get deleted occurrences from given recurrence series.

Parameter Type Description
recurrenceData string | number | Record Accepts the parent ID of the event object or parent event object

Returns Record[]

getEventDetails

To retrieve the appointment object from element.

Parameter Type Description
element Element Denotes the event UI element on the Schedule.

Returns Record

getEventMaxID

Get the maximum id of an event.

Returns number | string

getEvents

Retrieves the entire collection of events bound to the Schedule.

Parameter Type Description
startDate (optional) Date Accepts the start date.
endDate (optional) Date Accepts te end date.
includeOccurrences (optional) boolean Accepts the boolean value to process the occurrence from recurrence series.

Returns Record[]

getIndexFromResourceId

Select the resources to the based on id.

Parameter Type Description
id string | number id of the resource defined in resources collection.
name (optional) string Name of the resource defined in resources collection.

Returns number

getLocalData

Returns the persistence data for component

Returns any

getOccurrencesByID

Retrieves the occurrences of a single recurrence event based on the provided parent ID.

Parameter Type Description
eventID number | string ID of the parent recurrence data from which the occurrences are fetched.

Returns Record[]

getOccurrencesByRange

Retrieves all the occurrences that lies between the specific start and end time range.

Parameter Type Description
startTime Date Denotes the start time range.
endTime Date Denotes the end time range.

Returns Record[]

getResourceCollections

To get the resource collection

Returns ResourcesModel[]

getResourcesByIndex

Retrieves the resource details based on the provided resource index.

Parameter Type Description
index number index of the resources at the last level.

Returns ResourceDetails

getRootElement

Returns the route element of the component

Returns HTMLElement

getSelectedElements

Retrieves the selected cell elements.

Returns Element[]

getViewDates

Retrieves an array of dates based on the specified date collection direction.

Parameter Type Description
type NavigationDirection The direction for date collection. Options are:
- ‘Previous’: Returns the previous date range collection from the current rendered date.
- ‘Next’: Returns the next date range collection from the current rendered date.
- ‘Current’: Returns the current rendered date collection.

Returns Date[]

handleUnload

Handling unload event to persist data when enable persistence true

Returns void

hideSpinner

When the spinner is shown manually using showSpinner method, it can be hidden using this hideSpinner method.

Returns void

importICalendar

Imports the events from an .ics file downloaded from any of the calendars like Google or Outlook into the Scheduler. This method accepts the blob object or string format of an .ics file to be imported as a mandatory argument.

Parameter Type Description
fileContent Blob | string Accepts the file object or string format of an .ics file.

Returns void

isSlotAvailable

To check whether the given time range slots are available for event creation or already occupied by other events. This method currently focuses on validating appointments within the current view date range. However, it does not extend this availability check to recurrence occurrences outside of the current date range.

Parameter Type Description
startTime Date | Record Denotes the start time of the slot.
endTime (optional) Date Denotes the end time of the slot.
groupIndex (optional) number Defines the resource index from last level.

Returns boolean

openEditor

To manually open the event editor on specific time or on certain events.

Parameter Type Description
data Record It can be either cell data or event data.
action CurrentAction Defines the action for which the editor needs to be opened such as either for new event creation or
for editing of existing events. The applicable action names that can be used here are Add, Save, EditOccurrence
and EditSeries.
isEventData (optional) boolean It allows to decide whether the editor needs to be opened with the clicked cell details or with the
passed event details.
repeatType (optional) number It opens the editor with the recurrence options based on the provided repeat type.

Returns void

openQuickInfoPopup

To manually open the quick info popup based on cell or event details.

Parameter Type Description
data Record Defines the cell or event data. If the data contains valid ID, it will open event quick info popup,
otherwise cell quick info popup displayed.

Returns void

paste

Method to create a paste event with clipboard data

Parameter Type Description
targetElement HTMLElement Accepts HTMLElement

Returns void

print

Method allows to print the scheduler.

Parameter Type Description
printOptions (optional) ScheduleModel The export options to be set before start with exporting
the Scheduler events to the print window.

Returns void

refresh

Applies all the pending property changes and render the component again.

Returns void

refreshEvents

Refreshes the event dataSource. This method may be useful when the events alone in the schedule needs to be re-rendered.

Parameter Type Description
isRemoteRefresh boolean Accepts the boolean to refresh data from remote or local

Returns void

refreshLayout

Refreshes the Schedule layout without re-render.

Returns void

refreshTemplates

Method to refresh the given Schedule templates

Parameter Type Description
templateName (optional) string Accepts the template name

Returns void

removeEventListener

Removes the handler from the given event listener.

Parameter Type Description
eventName string A String that specifies the name of the event to remove
handler Function Specifies the function to remove

Returns void

removeResource

Removes the specified resource.

Parameter Type Description
resourceId string | string[] | number | number[] Specifies the resource id to be removed.
name string Specifies the resource name from which the id should be referred.

Returns void

resetWorkHours

Removes or resets different working hours on the required working days by accepting the required start and end time as well as the date collection as its parameters. if no parameters has been passed to this function, it will remove all the work hours.

Parameter Type Description
dates Date[] Collection of dates on which the given start and end hour range need to be applied.
start (optional) string Defines the work start hour.
end (optional) string Defines the work end hour.
groupIndex (optional) number Defines the resource index from last level.

Returns void

saveEvent

Updates the changes made in the event object by passing it as an parameter into the dataSource.

Parameter Type Description
data Record | Record[] Single or collection of event objects to be saved into Schedule.
currentAction (optional) CurrentAction Denotes the action that takes place either for editing occurrence or series.
The valid current action names are EditOccurrence or EditSeries.

Returns void

scrollTo

Scrolls the Schedule content area to the specified time.

Parameter Type Description
hour string Accepts the time value in the skeleton format of ‘Hm’.
scrollDate (optional) Date Accepts the date object value.

Returns void

scrollToResource

This method allows scroll to the position of the any resources that available on the scheduler. This method is applicable for without Agenda and Month agenda views of the schedule.

Parameter Type Description
resourceId string | number Accepts the resource id in either string or number type
groupName (optional) string Accepts the name of the resource collection

Returns void

selectResourceByIndex

Select the resource based on group index in mobile mode.

Parameter Type Description
groupIndex number Defines the resource index based on last level.

Returns void

setRecurrenceEditor

Set the recurrence editor instance from custom editor template.

Parameter Type Description
recurrenceEditor RecurrenceEditor instance has passed to fetch the instance in event window.

Returns void

setResourceCollections

To set the resource collection

Parameter Type Description
resourceCol ResourcesModel[] Accepts the resource collections in ResourcesModel type
isEventDataRefresh boolean Accepts the boolean to refresh the appointment data source from remote or local

Returns void

setWorkHours

Sets different working hours on the required working days by accepting the required start and end time as well as the date collection as its parameters.

Parameter Type Description
dates Date[] Collection of dates on which the given start and end hour range needs to be applied.
start string Defines the work start hour.
end string Defines the work end hour.
groupIndex (optional) number Defines the resource index from last level.

Returns void

showSpinner

Allows to show the spinner on schedule at the required scenarios.

Returns void

Inject

Dynamically injects the required modules to the component.

Parameter Type Description
moduleList Function[] ?

Returns void

Events

actionBegin

EmitType<ActionEventArgs>

Triggers on beginning of every scheduler action.

actionComplete

EmitType<ActionEventArgs>

Triggers on successful completion of the scheduler actions.

actionFailure

EmitType<ActionEventArgs>

Triggers when a scheduler action gets failed or interrupted and an error information will be returned.

beforePaste

EmitType<ReturnType>

Triggers once when pasting an event on the scheduler.

cellClick

EmitType<CellClickEventArgs>

Triggers when the scheduler cells are single clicked or on single tap on the same cells in mobile devices.

cellDoubleClick

EmitType<CellClickEventArgs>

Triggers when the scheduler cells are double clicked.

created

EmitType<Record>

Triggers after the scheduler component is created.

dataBinding

EmitType<ReturnType>

Triggers before the data binds to the scheduler.

dataBound

EmitType<ReturnType>

Triggers once the event data is bound to the scheduler.

destroyed

EmitType<Record>

Triggers when the scheduler component is destroyed.

drag

EmitType<DragEventArgs>

Triggers when an appointment is being in a dragged state.

dragStart

EmitType<DragEventArgs>

Triggers when an appointment is started to drag.

dragStop

EmitType<DragEventArgs>

Triggers when the dragging of appointment is stopped.

eventClick

EmitType<EventClickArgs>

Triggers when the events are single clicked or on single tapping the events on the mobile devices.

eventDoubleClick

EmitType<EventClickArgs>

Triggers when the events are double clicked or on double tapping the events on the desktop devices.

eventRendered

EmitType<EventRenderedArgs>

Triggers before each of the event getting rendered on the scheduler user interface.

hover

EmitType<HoverEventArgs>

Triggers when the scheduler elements are hovered.

moreEventsClick

EmitType<MoreEventsClickArgs>

Triggers when the more events indicator are clicked.

Triggers before the date or view navigation takes place on scheduler.

popupClose

EmitType<PopupCloseEventArgs>

Triggers before any of the scheduler popups close on the page.

popupOpen

EmitType<PopupOpenEventArgs>

Triggers before any of the scheduler popups opens on the page.

renderCell

EmitType<RenderCellEventArgs>

Triggers before each element of the schedule rendering on the page.

resizeStart

EmitType<ResizeEventArgs>

Triggers when an appointment is started to resize.

resizeStop

EmitType<ResizeEventArgs>

Triggers when the resizing of appointment is stopped.

resizing

EmitType<ResizeEventArgs>

Triggers when an appointment is being in a resizing action.

select

EmitType<SelectEventArgs>

Triggers when multiple cells or events are selected on the Scheduler.

virtualScrollStart

EmitType<ScrollEventArgs>

Triggers when the scroll action is started. This event triggers only when allowVirtualScrolling or enableLazyLoading properties are enabled along with resource grouping.

virtualScrollStop

EmitType<ScrollEventArgs>

Triggers when the scroll action is stopped. This event triggers only when allowVirtualScrolling or enableLazyLoading properties are enabled along with resource grouping.

Contents
Contents

Search results

ScheduleComponent

ScheduleComponent represents the react Schedule.

<ScheduleComponent/>

Properties

agendaDaysCount

number

Sets the number of days to be displayed by default in Agenda View and in case of virtual scrolling, the number of days will be fetched on each scroll-end based on this count.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { ScheduleComponent, ViewsDirective, ViewDirective, Agenda, Inject, Resize, DragAndDrop } from '@syncfusion/ej2-react-schedule';

function App() {
  return (<ScheduleComponent agendaDaysCount={1}>
    <ViewsDirective>
      <ViewDirective option='Agenda'/>
    </ViewsDirective>
    <Inject services={[Agenda, Resize, DragAndDrop]} />
  </ScheduleComponent>);
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to 7

allowClipboard

boolean

Enables clipboard functionality for appointments, allowing them to be copied using keyboard shortcuts and pasted onto the Scheduler. When set to true, users can use keyboard shortcuts to cut, copy appointments and paste them into different time slots or calendars.

Defaults to false

allowDragAndDrop

boolean

When set to true, allows the appointments to move over the time slots. When an appointment is dragged, both its start and end time tends to change simultaneously allowing it to reschedule the appointment on some other time.

Defaults to true

allowInline

boolean

This property helps user to add/edit the event in inline. By default, it is set to false.

Defaults to false

allowKeyboardInteraction

boolean

When set to true, allows the keyboard interaction to take place on Schedule.

Defaults to true

allowMultiCellSelection

boolean

This property helps user to allow/prevent the selection of multiple cells. By default, it is set to true.

Defaults to true

allowMultiDrag

boolean

This property helps to drag the multiple selected events. By default, it is set to false.

Defaults to false

allowMultiRowSelection

boolean

This property helps user to allow/prevent the selection of multiple days(rows). By default, it is set to true.

Defaults to true

allowOverlap

boolean

Specifies whether overlapping appointments are allowed within the same time slot in the Scheduler.

Defaults to true

allowResizing

boolean

When set to true, allows the resizing of appointments. It allows the rescheduling of appointments either by changing the start or end time by dragging the event resize handlers.

Defaults to true

allowSwiping

boolean

Defines whether to enable date navigations via swipe in touch devices or not.

Defaults to true

calendarMode

CalendarType

It allows the Scheduler to display in other calendar modes. By default, Scheduler is displayed in Gregorian calendar mode.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject, Resize, DragAndDrop } from '@syncfusion/ej2-react-schedule';

function App() {
  return (<ScheduleComponent calendarMode="Islamic">
    <Inject services={[Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]} />
  </ScheduleComponent>);
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

To change the mode, you can set either Gregorian or Islamic as a value to this calendarMode property.

Defaults to ‘Gregorian’

cellHeaderTemplate

string | function | JSX.Element

It accepts either the string or HTMLElement as template design content and parse it appropriately before displaying it onto the month date cells. This template is only applicable for month view day cells.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { ScheduleComponent, Month, Inject, ViewsDirective, ViewDirective } from "@syncfusion/ej2-react-schedule";
import { Internationalization } from '@syncfusion/ej2-base';

function App() {
  const instance = new Internationalization();
  const getDateHeaderText = (props): JSX.Element => {
    return (<div>{instance.formatDate(props.date, { skeleton: "Ed" })}</div>);
  }
  return (<ScheduleComponent height='550px' cellHeaderTemplate={getDateHeaderText}>
    <ViewsDirective>
      <ViewDirective option='Month' />
    </ViewsDirective>
    <Inject services={[Month]} />
  </ScheduleComponent>)
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to null

cellTemplate

string | function | JSX.Element

The template option which is used to render the customized work cells on the Schedule. Here, the template accepts either the string or HTMLElement as template design and then the parsed design is displayed onto the work cells. The fields accessible via template are as follows.

  • date: Returns the date of the cell.
  • groupIndex: Returns the group index of the cell.
  • type: Returns the type of the work cell. Refer to the below code snippet.
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { ScheduleComponent, Day, Week, TimelineViews, Month, Inject, ViewsDirective, 
ViewDirective, CellTemplateArgs } from '@syncfusion/ej2-react-schedule';

function App() {
  const getMonthCellContent = (date: Date) => {
    if (date.getMonth() === 10 && date.getDate() === 23) {
      return '<img src= "https://ej2.syncfusion.com/demos/src/schedule/images/birthday.svg" />';
    } else if (date.getDate() === 9) {
      return '<img src= "https://ej2.syncfusion.com/demos/src/schedule/images/get-together.svg" />';
    }
    return '';
  }
  const getWorkCellText = (date: Date) => {
    let weekEnds: number[] = [0, 6];
    if (weekEnds.indexOf(date.getDay()) >= 0) {
      return "<img src='https://ej2.syncfusion.com/demos/src/schedule/images/newyear.svg' />";
    }
    return '';
  };
  const cellTemplate = (props: CellTemplateArgs): JSX.Element => {
    if (props.type === "workCells") {
      const workCellTemplate = { __html: getWorkCellText(props.date) };
      return (<div className="templatewrap" dangerouslySetInnerHTML= {workCellTemplate}></div>);
    }
    if (props.type === "monthCells") {
      const monthCellTemplate = { __html: getMonthCellContent(props.date) };
      return (<div className="templatewrap" dangerouslySetInnerHTML={monthCellTemplate}></div>);
    }
    return (<div></div>);
  }
  return <ScheduleComponent width='100%' height='550px' selectedDate={new Date(2017, 11, 15)} cellTemplate={cellTemplate}>
    <ViewsDirective>
      <ViewDirective option='Day' />
      <ViewDirective option='Week' />
      <ViewDirective option='TimelineWeek' />
      <ViewDirective option='Month' />
    </ViewsDirective>
    <Inject services={[Day, Week, TimelineViews, Month]} />
  </ScheduleComponent>
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to null

cssClass

string

It is used to customize the Schedule which accepts custom CSS class names that defines specific user-defined styles and themes to be applied on the Schedule element.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject, Resize, DragAndDrop } from '@syncfusion/ej2-react-schedule';

function App() {
    return (<ScheduleComponent cssClass='schedule-cell-dimension'>
      <Inject services={[Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]}/>
    </ScheduleComponent>);
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to null

currentView

View

To set the active view on scheduler, the currentView property can be used and it usually accepts either of the following available view options. The view option specified in this property will be initially loaded on the schedule.

  • Day: Denotes Day view of the scheduler.
  • Week: Denotes Week view of the scheduler.
  • WorkWeek: Denotes Work Week view of the scheduler.
  • Month: Denotes Month view of the scheduler.
  • Year: Denotes Year view of the scheduler.
  • Agenda: Denotes Agenda view of the scheduler.
  • MonthAgenda: Denotes Month Agenda view of the scheduler.
  • TimelineDay: Denotes Timeline Day view of the scheduler.
  • TimelineWeek: Denotes Timeline Week view of the scheduler.
  • TimelineWorkWeek: Denotes Timeline Work Week view of the scheduler.
  • TimelineMonth: Denotes Timeline Month view of the scheduler.
  • TimelineYear: Denotes Timeline Year view of the scheduler.
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject, Resize, DragAndDrop } from '@syncfusion/ej2-react-schedule';

function App() {
    return (
      <ScheduleComponent width='100%' height='550px' currentView='Agenda'>
        <Inject services={[Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]}/>
      </ScheduleComponent>
    )
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to ‘Week’

dateFormat

string

By default, Schedule follows the date-format as per the default culture assigned to it. It is also possible to manually set specific date format by using the dateFormat property.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject, Resize, DragAndDrop } from '@syncfusion/ej2-react-schedule';

function App() {
  return <ScheduleComponent height='550px' dateFormat="dd-MMM-yyyy">
    <Inject services={[Day, Week, WorkWeek, Month,  Resize, DragAndDrop]} />
  </ScheduleComponent>
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

The format of the date range label in the header bar depends on the dateFormat value or else based on the locale assigned to the Schedule.

Defaults to null

dateHeaderTemplate

string | function | JSX.Element

It accepts either the string or HTMLElement as template design content and parse it appropriately before displaying it onto the date header cells. The field that can be accessed via this template is date.

import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { ScheduleComponent, ViewsDirective, ViewDirective, Day, Week, WorkWeek, Inject, TimelineViews, Resize, DragAndDrop } from '@syncfusion/ej2-react-schedule';
import { Internationalization } from '@syncfusion/ej2-base';

function App() {
    const instance = new Internationalization();
    const getDateHeaderText = (value) => {
        return instance.formatDate(value, { skeleton: 'Ed' });
    }
    const getWeather = (value) => {
        switch (value.getDay()) {
            case 0:
                return '<div class="weather-text">25°C</div>';
            case 1:
                return '<div class="weather-text">18°C</div>';
            case 2:
                return '<div class="weather-text">10°C</div>';
            case 3:
                return '<div class="weather-text">16°C</div>';
            case 4:
                return '<div class="weather-text">8°C</div>';
            case 5:
                return '<div class="weather-text">27°C</div>';
            case 6:
                return '<div class="weather-text">17°C</div>';
            default:
                return null;
        }
    }
    const dateHeaderTemplate = (props) => {
        const dateTemplate = { __html: getWeather(props.date) };
        return (<div><div>{getDateHeaderText(props.date)}</div><div className="date-text" dangerouslySetInnerHTML={dateTemplate}></div>
        </div>);
    }
    return (<ScheduleComponent width='100%' height='550px' cssClass='schedule-date-header-template' selectedDate={new Date(2018, 1, 15)}  dateHeaderTemplate={dateHeaderTemplate}>
        <ViewsDirective>
            <ViewDirective option='Day' />
            <ViewDirective option='Week' />
            <ViewDirective option='WorkWeek' />
            <ViewDirective option='TimelineWeek' />
        </ViewsDirective>
        <Inject services={[Day, Week, WorkWeek, TimelineViews, Resize, DragAndDrop]} />
    </ScheduleComponent>);
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to null

dateRangeTemplate

string | function | JSX.Element

It accepts either the string or HTMLElement as template design content and parse it appropriately before displaying it onto the header date range.

Defaults to null

dayHeaderTemplate

string | function | JSX.Element

It accepts either the string or HTMLElement as template design content and parse it appropriately before displaying it onto the day header cells. This template is only applicable for year view header cells.

Defaults to null

editorFooterTemplate

string | function | JSX.Element

The template option to render the customized footer of the editor window.

Defaults to null

editorHeaderTemplate

string | function | JSX.Element

The template option to render the customized header of the editor window.

Defaults to null

editorTemplate

string | function | JSX.Element

The template option to render the customized editor window. The form elements defined within this template should be accompanied with e-field class, so as to fetch and process it from internally.

import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { ScheduleComponent, ViewsDirective, ViewDirective, Day, Week, WorkWeek, Month, Agenda, Inject, Resize, DragAndDrop } from '@syncfusion/ej2-react-schedule';
import { DateTimePickerComponent } from '@syncfusion/ej2-react-calendars';
import { DropDownListComponent } from '@syncfusion/ej2-react-dropdowns';

function App() {
  const onPopupOpen = (args) => {
    if (args.type === 'Editor') {
      let statusElement = args.element.querySelector('#EventType');
      if (statusElement) {
        statusElement.setAttribute('name', 'EventType');
      }
    }
  }
  const eventEditorStyle = { width: "100%", cellpadding: "5"}
  const inputStyle = {width: "100%"}
  const DescriptionStyle = {width: "100%", height: "60px !important", resize: "vertical"}
  const editorTemplate = (props) => {
    return (props !== undefined ? <table className="custom-event-editor" style={eventEditorStyle}><tbody>
      <tr><td className="e-textlabel">Summary</td><td colSpan={4}>
        <input id="Summary" className="e-field e-input" type="text" name="Subject" style={inputStyle}/>
      </td></tr>
      <tr><td className="e-textlabel">Status</td><td colSpan={4}>
        <DropDownListComponent id="EventType" placeholder='Choose status' data-name="EventType" className="e-field" style={inputStyle} dataSource={['New', 'Requested', 'Confirmed']} value={props.EventType || null}></DropDownListComponent>
      </td></tr>
      <tr><td className="e-textlabel">From</td><td colSpan={4}>
        <DateTimePickerComponent format='dd/MM/yy hh:mm a' id="StartTime" data-name="StartTime" value={new Date(props.startTime || props.StartTime)} className="e-field"></DateTimePickerComponent>
      </td></tr>
      <tr><td className="e-textlabel">To</td><td colSpan={4}>
        <DateTimePickerComponent format='dd/MM/yy hh:mm a' id="EndTime" data-name="EndTime" value={new Date(props.endTime || props.EndTime)} className="e-field"></DateTimePickerComponent>
      </td></tr>
      <tr><td className="e-textlabel">Reason</td><td colSpan={4}>
        <textarea id="Description" className="e-field e-input" name="Description" rows={3} cols={50} style={DescriptionStyle}></textarea>
      </td></tr></tbody></table> : <div></div>);
  }
  return (<ScheduleComponent width='100%' height='550px' selectedDate={new Date(2018, 1, 15)} editorTemplate={editorTemplate.bind(this)} showQuickInfo={false} popupOpen={onPopupOpen.bind(this)}>
    <Inject services={[Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]} />
  </ScheduleComponent>);
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to null

enableAdaptiveUI

boolean

When set to true, the header view navigations are listed under the popup and if we enable resource grouping, the compact view will be enabled.

Defaults to false

enableAllDayScroll

boolean

When set to true, If valid, the scroll on the all day row is activated when the all day row height reaches the max height when the all day row is expanded.

Defaults to false

enableHtmlSanitizer

boolean

Specifies whether to enable the rendering of untrusted HTML values in the Schedule component. When this property is enabled, the component will sanitize any suspected untrusted strings and scripts before rendering them.

Defaults to true

enablePersistence

boolean

Enable or disable persisting component’s state between page reloads.

Defaults to false

enableRecurrenceValidation

boolean

The recurrence validation will be done by default. When this property is set to false, the recurrence validation will be skipped.

Defaults to true

enableRtl

boolean

Enable or disable rendering component in right to left direction.

Defaults to false

endHour

string

It is used to specify the end hour, at which the Schedule ends. It too accepts the time string in a short skeleton format.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject, Resize, DragAndDrop } from '@syncfusion/ej2-react-schedule';

function App() {
  return (<ScheduleComponent width='100%' height='550px' endHour='18:00'>
    <Inject services={[Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]} />
  </ScheduleComponent>);
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to ‘24:00’

eventDragArea

string

It enables the external drag and drop support for appointments on scheduler, to be able to move them out of the scheduler layout. When the drag area is explicitly set with specific DOM element name, the appointments can be dragged anywhere within the specified drag area location.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject, Resize, DragAndDrop } from '@syncfusion/ej2-react-schedule';

function App() {
  return (<ScheduleComponent width='100%' height='550px' eventDragArea='body'>
    <Inject services={[Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]} />
  </ScheduleComponent>);
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to null

eventSettings

EventSettingsModel

Complete set of settings related to Schedule events to bind it to local or remote dataSource, map applicable database fields and other validation to be carried out on the available fields.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { useRef } from 'react';
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop, Inject } from '@syncfusion/ej2-react-schedule';

function App() {
  const scheduleObj = useRef<ScheduleComponent>(null);   
  const scheduleData: object[] = [
    {
        Subject: 'Paris',
        StartTime: new Date(2023, 1, 15, 10, 0),
        EndTime: new Date(2023, 1, 15, 12, 30)
    }
  ];
  const eventSettings = { dataSource: scheduleData };
  return (
    <ScheduleComponent ref={scheduleObj} height="550px" selectedDate={new Date(2023, 1, 15)} eventSettings={eventSettings}>
      <Inject services={[Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]} />
    </ScheduleComponent>
  );
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to null

firstDayOfWeek

number

This option allows the user to set the first day of a week on Schedule. It should be based on the locale set to it and each culture defines its own first day of week values. If needed, the user can set it manually on his own by defining the value through this property. It usually accepts the integer values, whereby 0 is always denoted as Sunday, 1 as Monday and so on.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject, Resize, DragAndDrop } from '@syncfusion/ej2-react-schedule';

function App() {
    return (<ScheduleComponent firstDayOfWeek={2}>
      <Inject services={[Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]}/>
    </ScheduleComponent>);
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to 0

firstMonthOfYear

number

This property helps render the year view customized months. By default, it is set to 0.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import {
  ScheduleComponent, ViewsDirective, ViewDirective, Year, TimelineYear, Inject, Resize,
  DragAndDrop
} from '@syncfusion/ej2-react-schedule';

function App() {
  return (<ScheduleComponent firstMonthOfYear={2}>
    <ViewsDirective>
      <ViewDirective option='Year'/>
      <ViewDirective option='TimelineYear'/>
    </ViewsDirective>
    <Inject services={[Year, TimelineYear, Resize, DragAndDrop]} />
  </ScheduleComponent>);
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to 0

group

GroupModel

Allows defining the group related settings of multiple resources. When this property is non-empty, it means that the resources will be grouped on the schedule layout based on the provided resource names.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import {
  Week, Month, TimelineViews, TimelineMonth, Agenda, ScheduleComponent, ViewsDirective, ViewDirective,
  ResourcesDirective, ResourceDirective, Inject, EventSettingsModel, Resize, DragAndDrop
} from '@syncfusion/ej2-react-schedule';

function App() {
  const group = { resources: ['Airlines'] }
  const resourceData: Object[] =
    [
      { AirlineName: "Airways 1", AirlineId: 1, AirlineColor: "#EA7A57" },
      { AirlineName: "Airways 2", AirlineId: 2, AirlineColor: "#357cd2" },
      { AirlineName: "Airways 3", AirlineId: 3, AirlineColor: "#7fa900" }
    ];
  return (
    <ScheduleComponent width='100%' height='550px' group={group}>
      <ResourcesDirective>
        <ResourceDirective field='AirlineId' title='Airline Name' name='Airlines' allowMultiple={true}
          dataSource={resourceData} textField='AirlineName' idField='AirlineId' colorField='AirlineColor'>
        </ResourceDirective>
      </ResourcesDirective>
      <Inject services={[Week, Month, TimelineViews, TimelineMonth, Agenda, Resize, DragAndDrop]} />
    </ScheduleComponent>
  )
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to {}

headerIndentTemplate

string | function | JSX.Element

Template option to customize the header indent bar. Here, the template accepts either the string or HTMLElement as template design and then the parsed design is displayed onto the header indent cell. Refer to the below code snippet.

import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { Day, Week, WorkWeek, Resize, DragAndDrop, ScheduleComponent, Inject } from '@syncfusion/ej2-react-schedule';

function App() {
  const headerIndentTemplate = (props) => {
     return props.className[0] == 'e-header-cells' ? (
      <div className="template-wrap">Template</div>
    ) : null;
  }
  return (<ScheduleComponent width='100%' height='550px' headerIndentTemplate={headerIndentTemplate}>
    <Inject services={[Day, Week, WorkWeek, Resize, DragAndDrop]} />
  </ScheduleComponent>)
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to null

headerRows

HeaderRowsModel[]

Allows defining the collection of custom header rows to display the year, month, week, date and hour label as an individual row on the timeline view of the scheduler.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import {
  ScheduleComponent, HeaderRowDirective, HeaderRowsDirective, TimelineViews, Inject,
  ViewsDirective, ViewDirective
} from '@syncfusion/ej2-react-schedule';

function App() {
  return (<ScheduleComponent width='100%' height='550px' selectedDate={new Date(2018, 11, 31)} startHour='09:00' endHour='13:00'>
    <HeaderRowsDirective>
      <HeaderRowDirective option='Year' />
      <HeaderRowDirective option='Month' />
      <HeaderRowDirective option='Week' />
      <HeaderRowDirective option='Date' />
      <HeaderRowDirective option='Hour' />
    </HeaderRowsDirective>
    <ViewsDirective>
      <ViewDirective option='TimelineWeek' />
    </ViewsDirective>
    <Inject services={[TimelineViews]} />
  </ScheduleComponent>)
};
const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to []

height

string | number

Sets the height of the Schedule component, accepting both string and number values.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject, Resize, DragAndDrop } from '@syncfusion/ej2-react-schedule';

function App() {
  return (
    <ScheduleComponent height='550px'>
      <Inject services={[Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]} />
    </ScheduleComponent>
  );
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

The string type includes either pixel or percentage values. When height is set with specific pixel value, then the Schedule will be rendered to that specified space. In case, if auto value is set, then the height of the Schedule gets auto-adjusted within the given container.

Defaults to ‘auto’

hideEmptyAgendaDays

boolean

The days which does not has even a single event to display will be hidden from the UI of Agenda View by default. When this property is set to false, the empty dates will also be displayed on the Schedule.

Defaults to true

locale

string

Overrides the global culture and localization value for this component. Default global culture is ‘en-US’.

Defaults to

maxDate

Date

To define the maximum date on the Schedule, maxDate property can be defined. Usually, it defaults to the new Date(2099, 11, 31).

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject, Resize, DragAndDrop } from '@syncfusion/ej2-react-schedule';

function App() {
  return (<ScheduleComponent maxDate={new Date(2021, 0, 1)}>
    <Inject services={[Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]} />
  </ScheduleComponent>)
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to new Date(2099, 11, 31)

minDate

Date

To define the minimum date on the Schedule, minDate property can be defined. Usually, it defaults to the new Date(1900, 0, 1).

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject, Resize, DragAndDrop } from '@syncfusion/ej2-react-schedule';

function App() {
  return (<ScheduleComponent minDate={new Date(2020,6,1)}>
    <Inject services={[Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]} />
  </ScheduleComponent>)
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to new Date(1900, 0, 1)

monthHeaderTemplate

string | function | JSX.Element

It accepts either the string or HTMLElement as template design content and parse it appropriately before displaying it onto the month header cells. This template is only applicable for year view header cells.

Defaults to null

monthsCount

number

This option allows the user to set the number of months count to be displayed on the Schedule.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { ScheduleComponent, ViewsDirective, ViewDirective, TimelineYear, Inject, Resize, 
DragAndDrop } from '@syncfusion/ej2-react-schedule';

function App() {
  return (<ScheduleComponent monthsCount={16}>
    <ViewsDirective>
        <ViewDirective option='TimelineYear' ></ViewDirective>
    </ViewsDirective>
    <Inject services={[TimelineYear, Resize, DragAndDrop]} />
  </ScheduleComponent>)
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to 12

overscanCount

number

Specifies the number of additional rows or columns to render outside the visible area during virtual scrolling. This property helps in achieving smoother scrolling by pre-loading data just outside the visible region.

Defaults to 3

quickInfoOnSelectionEnd

boolean

This property helps to show quick popup after multiple cell selection. By default, it is set to false.

Defaults to false

quickInfoTemplates

QuickInfoTemplatesModel

The template option to customize the quick window. The three sections of the quick popup whereas the header, content, and footer can be easily customized with individual template option.

import { useRef } from 'react';
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import {
  ScheduleComponent, ResourcesDirective, ResourceDirective, Day, Week, WorkWeek, Month,
  Agenda, MonthAgenda, Inject, ResourcesModel, CellClickEventArgs, CurrentAction, EventSettingsModel
} from '@syncfusion/ej2-react-schedule';
import { Internationalization } from '@syncfusion/ej2-base';
import { DropDownListComponent } from '@syncfusion/ej2-react-dropdowns';
import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';

function App() {
  const eventTypeObj = useRef<DropDownListComponent>(null);
  const titleObj = useRef<TextBoxComponent>(null);
  const notesObj = useRef<TextBoxComponent>(null);
  const scheduleObj = useRef<ScheduleComponent>(null);
  const intl: Internationalization = new Internationalization();
  const headerTemplate = (props: { [key: string]: Date }): JSX.Element => {
    return (
      <div className="quick-info-header">
        <div className="quick-info-header-content" style={getHeaderStyles(props)}>
          <div className="quick-info-title">{getHeaderTitle(props)}</div>
          <div className="duration-text">{getHeaderDetails(props)}</div>
        </div>
      </div>
    );
  }

  const contentTemplate = (props: { [key: string]: string }): JSX.Element => {
    return (
      <div className="quick-info-content">
        {props.elementType === 'cell' ?
          <div className="e-cell-content">
            <div className="content-area">
              <TextBoxComponent id="title" ref={titleObj} placeholder="Title" />
            </div>
            <div className="content-area">
              <DropDownListComponent id="eventType" ref={eventTypeObj} dataSource={roomData}
                fields= placeholder="Choose Type" index={0} popupHeight="200px" />
            </div>
            <div className="content-area">
              <TextBoxComponent id="notes" ref={notesObj} placeholder="Notes" />
            </div>
          </div>
          :
          <div className="event-content">
            <div className="meeting-type-wrap">
              <label>Subject</label>:
              <span>{props.Subject}</span>
            </div>
            <div className="meeting-subject-wrap">
              <label>Type</label>:
              <span>{getEventType(props)}</span>
            </div>
            <div className="notes-wrap">
              <label>Notes</label>:
              <span>{props.Description}</span>
            </div>
          </div>
        }
      </div>
    );
  }

  const footerTemplate = (props: { [key: string]: Object }): JSX.Element => {
    return (
      <div className="quick-info-footer">
        {props.elementType === "cell" ?
          <div className="cell-footer">
            <ButtonComponent id="more-details" cssClass='e-flat' content="More Details" onClick={buttonClickActions.bind(this)} />
            <ButtonComponent id="add" cssClass='e-flat' content="Add" isPrimary={true} onClick={buttonClickActions.bind(this)} />
          </div>
          :
          <div className="event-footer">
            <ButtonComponent id="delete" cssClass='e-flat' content="Delete" onClick={buttonClickActions.bind(this)} />
            <ButtonComponent id="more-details" cssClass='e-flat' content="More Details" isPrimary={true} onClick={buttonClickActions.bind(this).bind(this)} />
          </div>
        }
      </div>
    );
  }
  const roomData: { [key: string]: Object }[] = [
    { Name: 'Jammy', Id: 1, Capacity: 20, Color: '#ea7a57', Type: 'Conference' },
    { Name: 'Tweety', Id: 2, Capacity: 7, Color: '#7fa900', Type: 'Cabin' },
    { Name: 'Nestle', Id: 3, Capacity: 5, Color: '#5978ee', Type: 'Cabin' },
    { Name: 'Phoenix', Id: 4, Capacity: 15, Color: '#fec200', Type: 'Conference' },
    { Name: 'Mission', Id: 5, Capacity: 25, Color: '#df5286', Type: 'Conference' },
    { Name: 'Hangout', Id: 6, Capacity: 10, Color: '#00bdae', Type: 'Cabin' },
    { Name: 'Rick Roll', Id: 7, Capacity: 20, Color: '#865fcf', Type: 'Conference' },
    { Name: 'Rainbow', Id: 8, Capacity: 8, Color: '#1aaa55', Type: 'Cabin' },
    { Name: 'Swarm', Id: 9, Capacity: 30, Color: '#df5286', Type: 'Conference' },
    { Name: 'Photogenic', Id: 10, Capacity: 25, Color: '#710193', Type: 'Conference' }
  ];
  const quickInfoTemplates = {
    header: headerTemplate as any,
    content: contentTemplate as any,
    footer: footerTemplate as any
  };
  const getResourceData = (data: { [key: string]: Object }): { [key: string]: Object } => {
    const resources: ResourcesModel = scheduleObj.current.getResourceCollections().slice(-1)[0];
    const resourceData: { [key: string]: Object } = (resources.dataSource as Object[]).filter((resource: { [key: string]: Object }) =>
      resource.Id === data.RoomId)[0] as { [key: string]: Object };
    return resourceData;
  }

  const getHeaderStyles = (data: { [key: string]: Object }): Object => {
    if (data.elementType === 'cell') {
      return { alignItems: 'center', color: '#919191' };
    } else {
      const resourceData: { [key: string]: Object } = getResourceData(data);
      return { background: resourceData.Color, color: '#FFFFFF' };
    }
  }

  const getHeaderTitle = (data: { [key: string]: Object }): string => {
    return (data.elementType === 'cell') ? 'Add Appointment' : 'Appointment Details';
  }

  const getHeaderDetails = (data: { [key: string]: Date }): string => {
    return intl.formatDate(data.StartTime, { type: 'date', skeleton: 'full' }) + ' (' +
      intl.formatDate(data.StartTime, { skeleton: 'hm' }) + ' - ' +
      intl.formatDate(data.EndTime, { skeleton: 'hm' }) + ')';

  }

  const getEventType = (data: { [key: string]: string }): string => {
    const resourceData: { [key: string]: Object } = getResourceData(data);
    return resourceData.Name as string;
  }

  const buttonClickActions = (e: Event) => {
    const quickPopup: HTMLElement = scheduleObj.current.element.querySelector('.e-quick-popup-wrapper') as HTMLElement;
    const getSlotData: Function = (): { [key: string]: Object } => {
      const cellDetails: CellClickEventArgs = scheduleObj.current.getCellDetails(scheduleObj.current.getSelectedElements());
      const addObj: { [key: string]: Object } = {};
      addObj.Id = scheduleObj.current.getEventMaxID();
      addObj.Subject = titleObj.current.value;
      addObj.StartTime = new Date(+cellDetails.startTime);
      addObj.EndTime = new Date(+cellDetails.endTime);
      addObj.Description = notesObj.current.value;
      addObj.RoomId = eventTypeObj.current.value;
      return addObj;
    };
    if ((e.target as HTMLElement).id === 'add') {
      const addObj: { [key: string]: Object } = getSlotData();
      scheduleObj.current.addEvent(addObj);
    } else if ((e.target as HTMLElement).id === 'delete') {
      const eventDetails: { [key: string]: Object } = scheduleObj.current.activeEventData.event as { [key: string]: Object };
      let currentAction: CurrentAction = 'Delete';
      if (eventDetails.RecurrenceRule) {
        currentAction = 'DeleteOccurrence';
      }
      scheduleObj.current.deleteEvent(eventDetails, currentAction);
    } else {
      const isCellPopup: boolean = (quickPopup.firstElementChild as HTMLElement).classList.contains('e-cell-popup');
      const eventDetails: { [key: string]: Object } = isCellPopup ? getSlotData() :
        scheduleObj.current.activeEventData.event as { [key: string]: Object };
      let currentAction: CurrentAction = isCellPopup ? 'Add' : 'Save';
      if (eventDetails.RecurrenceRule) {
        currentAction = 'EditOccurrence';
      }
      scheduleObj.current.openEditor(eventDetails, currentAction, true);
    }
    scheduleObj.current.closeQuickInfoPopup();
  }

  return (
    <div className='schedule-control-section'>
      <div className='col-lg-12 control-section'>
        <div className='control-wrapper'>
          <ScheduleComponent id="schedule" cssClass='quick-info-template' ref={scheduleObj} height="650px"
            selectedDate={new Date(2020, 0, 9)} quickInfoTemplates={quickInfoTemplates}>
            <ResourcesDirective>
              <ResourceDirective field='RoomId' title='Room Type' name='MeetingRoom' textField='Name' idField='Id'
                colorField='Color' dataSource={roomData}></ResourceDirective>
            </ResourcesDirective>
            <Inject services={[Day, Week, WorkWeek, Month, Agenda, MonthAgenda]} />
          </ScheduleComponent>
        </div>
      </div>
    </div>
  );
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to null

readonly

boolean

When set to true, makes the Schedule to render in a read only mode. No CRUD actions will be allowed at this time.

Defaults to false

resourceHeaderTemplate

string | function | JSX.Element

Template option to customize the resource header bar. Here, the template accepts either the string or HTMLElement as template design and then the parsed design is displayed onto the resource header cells. The following can be accessible via template.

  • resource - All the resource fields.
  • resourceData - Object collection of current resource. Refer to the below code snippet.
import * as React from 'react';
import * as ReactDOM from "react-dom";
import {
  Week, Month, TimelineViews, TimelineMonth, Agenda, ScheduleComponent, GroupModel, ViewsDirective, EventSettingsModel, ViewDirective, ResourceDetails, ResourcesDirective, ResourceDirective, Inject, TreeViewArgs
} from '@syncfusion/ej2-react-schedule';

function App() {
  const getDoctorName = (value: ResourceDetails | TreeViewArgs): string => {
    return (((value as ResourceDetails).resourceData) ?
      (value as ResourceDetails).resourceData[(value as ResourceDetails).resource.textField] :
      (value as TreeViewArgs).resourceName) as string;
  }

  const getDoctorLevel = (value: ResourceDetails | TreeViewArgs): string => {
    let resourceName: string = getDoctorName(value);
    return (resourceName === 'Will Smith') ? 'Cardiologist' : (resourceName === 'Alice') ? 'Neurologist' : 'Orthopedic Surgeon';
  }
  const group: GroupModel = { resources: ['Doctors'] };

  const resourceData: Object[] = [
    { text: 'Will Smith', id: 1, color: '#ea7a57', designation: 'Cardioligst' },
    { text: 'Alice', id: 2, color: '#7fa900', designation: 'Neurologist' },
    { text: 'Robson', id: 3, color: '#7fa900', designation: 'Orthopedic Surgeon' }
  ];
  const resourceHeaderTemplate = (props): JSX.Element => {
    return (<div className="template-wrap">
      <div className="resource-detail"><div className="resource-name">{getDoctorName(props)}</div>
        <div className="resource-designation">{getDoctorLevel(props)}</div></div></div>
    );
  }
  return (<ScheduleComponent width='100%' height='550px' selectedDate={new Date(2018, 3, 1)} currentView='WorkWeek' resourceHeaderTemplate={resourceHeaderTemplate} group={group}>
    <ResourcesDirective>
      <ResourceDirective field='DoctorId' title='Doctor' name='Doctors' dataSource={resourceData} textField='text' idField='id' DesignationField='designation' colorField='color' >
      </ResourceDirective>
    </ResourcesDirective>
    <ViewsDirective>
      <ViewDirective option='Week' />
      <ViewDirective option='Month' />
      <ViewDirective option='TimelineWeek' />
      <ViewDirective option='TimelineMonth' />
      <ViewDirective option='Agenda' />
    </ViewsDirective>
    <Inject services={[Week, Month, TimelineViews, TimelineMonth, Agenda]} />
  </ScheduleComponent>)
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to null

resources

ResourcesModel[]

Allows defining the collection of resources to be displayed on the Schedule. The resource collection needs to be defined with unique resource names to identify it along with the respective dataSource and field mapping options.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import {
  Week, Month, TimelineViews, TimelineMonth, Agenda, ScheduleComponent, ViewsDirective, ViewDirective,
  ResourcesDirective, ResourceDirective, Inject, EventSettingsModel, Resize, DragAndDrop
} from '@syncfusion/ej2-react-schedule';

function App() {
  const group = { resources: ['Airlines'] }
  const resourceData: Object[] =
    [
      { AirlineName: "Airways 1", AirlineId: 1, AirlineColor: "#EA7A57" },
      { AirlineName: "Airways 2", AirlineId: 2, AirlineColor: "#357cd2" },
      { AirlineName: "Airways 3", AirlineId: 3, AirlineColor: "#7fa900" }
    ];
  return (
    <ScheduleComponent width='100%' height='550px' group={group}>
      <ResourcesDirective>
        <ResourceDirective field='AirlineId' title='Airline Name' name='Airlines' allowMultiple={true}
          dataSource={resourceData} textField='AirlineName' idField='AirlineId' colorField='AirlineColor'>
        </ResourceDirective>
      </ResourcesDirective>
      <Inject services={[Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]} />
    </ScheduleComponent>
  )
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to []

rowAutoHeight

boolean

when set to true, allows the height of the work-cells to adjust automatically based on the number of appointments present in those time ranges.

Defaults to false

selectedDate

Date

To mark the active (current) date on the Schedule, selectedDate property can be defined. Usually, it defaults to the current System date.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject } from '@syncfusion/ej2-react-schedule';

function App() {
  return (
    <ScheduleComponent height='550px' selectedDate={new Date(2023, 1, 15)}>
      <Inject services={[Day, Week, WorkWeek, Month, Agenda]} />
    </ScheduleComponent>
  )
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to ‘new Date()’

showHeaderBar

boolean

When set to false, hides the header bar of the Schedule from UI. By default, the header bar holds the date and view navigation options, to which the user can add their own custom items onto it.

Defaults to true

showQuickInfo

boolean

When set to true, displays a quick popup with cell or event details on single clicking over the cells or on events. By default, it is set to true.

Defaults to true

showTimeIndicator

boolean

When set to false, hides the current time indicator from the Schedule. Otherwise, it visually depicts the live current system time appropriately on the user interface.

Defaults to true

showWeekNumber

boolean

When set to true, displays the week number of the current view date range. By default, it is set to false.

Defaults to false

showWeekend

boolean

When set to false, it hides the weekend days of a week from the Schedule. The days which are not defined in the working days collection are usually treated as weekend days. Note: By default, this option is not applicable on Work Week view. For example, if the working days are defined as [1, 2, 3, 4], then the remaining days of that week will be considered as the weekend days and will be hidden on all the views.

Defaults to true

startHour

string

It is used to specify the starting hour, from which the Schedule starts to display. It accepts the time string in a short skeleton format and also, hides the time beyond the specified start time.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject } from '@syncfusion/ej2-react-schedule';

function App() {
  return (
    <ScheduleComponent startHour='10:00'>
      <Inject services={[Day, Week, WorkWeek, Month, Agenda]} />
    </ScheduleComponent>
  )
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to ‘00:00’

timeFormat

string

By default, Schedule follows the time-format as per the default culture assigned to it. It is also possible to manually set specific time format by using the timeFormat property.

Defaults to null

timeScale

TimeScaleModel

Allows to set different time duration on Schedule along with the customized grid count. It also has template option to customize the time slots with required time values in its own format.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject } from '@syncfusion/ej2-react-schedule';

function App () {
  const timeScale = { enable: true, interval: 60, slotCount: 6 };
  return (
    <ScheduleComponent timeScale={timeScale}>
      <Inject services={[Day, Week, WorkWeek, Month, Agenda]} />
    </ScheduleComponent>
  )
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to { enable: true, interval: 60, slotCount: 2, majorSlotTemplate: null, minorSlotTemplate: null }

timezone

string

Schedule will be assigned with specific timezone, so as to display the events in it accordingly. By default, Schedule dates are processed with System timezone, as no timezone will be assigned specifically to the Schedule at the initial time. Whenever the Schedule is bound to remote data services, it is always recommended to set specific timezone to Schedule to make the events on it to display on the same time irrespective of the system timezone. It usually accepts the valid IANA timezone names.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject } from '@syncfusion/ej2-react-schedule';

function App() {
  return (
    <ScheduleComponent timezone="UTC">
      <Inject services={[Day, Week, WorkWeek, Month, Agenda]} />
    </ScheduleComponent>
  )
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to null

timezoneDataSource

TimezoneFields[]

Allows to define the collection of timezone items in the Schedule. Only the items bound to this property get listed out in the timezone dropdown of the appointment window.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import {
  ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject, EventSettingsModel, Resize, DragAndDrop
} from '@syncfusion/ej2-react-schedule';

function App() {
  const data: object[] = [{
    Id: 1,
    Subject: 'Explosion of Betelgeuse Star',
    StartTime: new Date(2023, 1, 15, 10, 0),
    EndTime: new Date(2023, 1, 15, 12, 30)
  }, {
    Id: 2,
    Subject: 'Blue Moon Eclipse',
    StartTime: new Date(2023, 1, 16, 12, 0),
    EndTime: new Date(2023, 1, 16, 13, 0)
  }];
  const eventSettings: EventSettingsModel = { dataSource: data };

  return (<ScheduleComponent height='550px'
    selectedDate={new Date(2023, 1, 15)}
    eventSettings={eventSettings}
    timezoneDataSource={[
      { Value: 'Pacific/Niue', Text: 'Niue' },
      { Value: 'Pacific/Pago_Pago', Text: 'Pago Pago' },
      { Value: 'Pacific/Honolulu', Text: 'Hawaii Time' },
      { Value: 'Pacific/Rarotonga', Text: 'Rarotonga' },
      { Value: 'Pacific/Tahiti', Text: 'Tahiti' },
    ]}>
    <Inject services={[Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]} />
  </ScheduleComponent>)
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to timezoneData

toolbarItems

ToolbarItemModel[]

To render the custom toolbar items, the toolbarItems property can be used. It contains built-in and custom toolbar items. To avail the built-in toolbar items, the below string values are assigned to the name property of the ToolbarItemModel.

  • Previous: Schedule component navigates to the previous date from the current date.
  • Next: Schedule component navigates to the next date from the current date.
  • Today: Schedule component navigates to the current date from any date.
  • Views: Schedule component render the defined view options in the toolbar. If view option is not defined, then it will render default view options in the Schedule.
  • DateRangeText: Schedule component displays the current date text range.
  • NewEvent: Schedule component render the icon to add a new event.

Defaults to []

views

View[] | ViewsModel[]

This property holds the views collection and its configurations. It accepts either the array of view names or the array of view objects that holds different configurations for each views. By default, Schedule displays all the views namely Day, Week, Work Week, Month and Agenda. Example for array of views:

Example for array of view objects:

Defaults to ’[“Day”, “Week”, “WorkWeek”, “Month”, “Agenda”]’

weekRule

WeekRule

It allows the Scheduler to display week numbers based on following available week options. The week option specified in this property will be initially loaded on the schedule.

  • FirstDay: Denotes that the first week of the year starts on the first day of the year and ends before the following designated first day of the week.
  • FirstFourDayWeek:Denotes that the first week of the year is the first week with four or more days before the designated first day of the week.
  • FirstFullWeek: Denotes that the first week of the year begins on the first occurrence of the designated first day of the week on or after the first day of the year.
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject, Resize, DragAndDrop } from '@syncfusion/ej2-react-schedule';

function App() {
  return (
    <ScheduleComponent showWeekNumber={true} weekRule='FirstFourDayWeek'>
      <Inject services={[Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]} />
    </ScheduleComponent>
  );
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to ‘FirstDay’

width

string | number

Sets the width of the Schedule component, accepting both string and number values.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject } from '@syncfusion/ej2-react-schedule';

function App() {
  return (
    <ScheduleComponent width='100%'>
      <Inject services={[Day, Week, WorkWeek, Month, Agenda]} />
    </ScheduleComponent>
  );
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

The string value can be either pixel or percentage format. When set to auto, the Schedule width gets auto-adjusted and display its content related to the viewable screen size.

Defaults to ‘auto’

workDays

number[]

It is used to set the working days on Schedule. The only days that are defined in this collection will be rendered on the workWeek view whereas on other views, it will display all the usual days and simply highlights the working days with different shade.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import {
  ScheduleComponent, Week, WorkWeek, Day, Inject, Month, Agenda, EventSettingsModel, Resize, DragAndDrop
} from '@syncfusion/ej2-react-schedule';

function App() {
  const workingDays: number[] = [1, 3, 5];
  return (<ScheduleComponent workDays={workingDays} >
    <Inject services={[Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]} />
  </ScheduleComponent>)
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to ’[1, 2, 3, 4, 5]’

workHours

WorkHoursModel

The working hours should be highlighted on Schedule with different color shade and an additional option must be provided to highlight it or not. This functionality is handled through workHours property and the start work hour should be 9 AM by default and end work hour should point to 6 PM. The start and end working hours needs to be provided as Time value of short skeleton type.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import {
  ScheduleComponent, Week, WorkWeek, Day, Inject, Month, Agenda, EventSettingsModel, Resize, DragAndDrop
} from '@syncfusion/ej2-react-schedule';

function App() {
  const workHours: WorkHoursModel = {
    highlight: true, start: '11:00', end: '20:00'
  };

  return (<ScheduleComponent workHours={workHours}>
    <Inject services={[Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]} />
  </ScheduleComponent>)
};

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<App />);

Defaults to { highlight: true, start: ‘09:00’, end: ‘18:00’ }

Methods

addEvent

Adds the newly created event into the Schedule dataSource.

Parameter Type Description
data Record | Record[] Single or collection of event objects to be added into Schedule.

Returns void

addResource

Adds the resources to the specified index.

Parameter Type Description
resources Record | Record[] Accepts the resource data in single or collection of data.
name string Name of the resource defined in resources collection.
index number Index or position where the resource should be added.

Returns void

changeCurrentView

Current View could be change based on the provided parameters.

Parameter Type Description
viewName View Accept the view in the viewCollections.
viewIndex (optional) number Accept the viewIndex in the viewCollections.

Returns void

closeEditor

To manually close the event editor window

Returns void

closeOverlapAlert

To manually close the overlap validation Alert.

Returns void

closeQuickInfoPopup

To manually close the quick info popup

Returns void

closeTooltip

Closes the tooltip. For example, when the context menu is opened for an event, the tooltip can be closed by calling this method.

Returns void

collapseResource

This method allows to collapse the resource that available on the scheduler.

Parameter Type Description
resourceId string | number Accepts the resource id in either string or number type
name string Accepts the name of the resource collection

Returns void

copy

Method to copy events from an HTMLElement or an array of HTMLElements.

Parameter Type Description
elements HTMLElement[] Accepts an array of HTMLElement

Returns void

cut

Method to cut events from an HTMLElement or an array of HTMLElements.

Parameter Type Description
elements HTMLElement[] Accepts an array of HTMLElement

Returns void

deleteEvent

Deletes the events based on the provided ID or event collection in the argument list.

Parameter Type Description
id string | number | Record | Record[] Accepts the ID as string or number type or single or collection of the event object which needs to be removed from the Schedule.
currentAction (optional) CurrentAction Denotes the delete action that takes place either on occurrence or series events.
The valid current action names are Delete, DeleteOccurrence or DeleteSeries.

Returns void

destroy

Destroys the Schedule component.

Returns void

expandResource

This method allows to expand the resource that available on the scheduler.

Parameter Type Description
resourceId string | number Accepts the resource id in either string or number type
name string Accepts the name of the resource collection

Returns void

exportToExcel

Allows the Scheduler events data to be exported as an Excel file either in .xlsx or .csv file formats. By default, the whole event collection bound to the Scheduler gets exported as an Excel file. To export only the specific events of Scheduler, you need to pass the custom data collection as a parameter to this exportToExcel method. This method accepts the export options as arguments such as fileName, exportType, fields, customData, and includeOccurrences. The fileName denotes the name to be given for the exported file and the exportType allows you to set the format of an Excel file to be exported either as .xlsx or .csv. The custom or specific field collection of event dataSource to be exported can be provided through fields option and the custom data collection can be exported by passing them through the customData option. There also exists option to export each individual instances of the recurring events to an Excel file, by setting true or false to the includeOccurrences option, denoting either to include or exclude the occurrences as separate instances on an exported Excel file.

Parameter Type Description
excelExportOptions (optional) ExportOptions The export options to be set before start with exporting the Scheduler events to an Excel file.

Returns void

exportToICalendar

Exports the Scheduler events to a calendar (.ics) file. By default, the calendar is exported with a file name Calendar.ics. To change this file name on export, pass the custom string value as fileName to get the file downloaded with this provided name.

Parameter Type Description
fileName (optional) string Accepts the string value.
customData (optional) Record[] Accepts the collection of objects.

Returns void

generateEventOccurrences

Generates the occurrences of a single recurrence event based on the provided event.

Parameter Type Description
event Record Accepts the parent recurrence event from which the occurrences are generated.
startDate (optional) Date Accepts the start date for the event occurrences. If not provided, the event’s start date will be used.

Returns Record[]

getBlockEvents

Retrieves the entire collection of block events bound to the Schedule.

Parameter Type Description
startDate (optional) Date Accepts the start date.
endDate (optional) Date Accepts te end date.
includeOccurrences (optional) boolean Accepts the boolean value to process the occurrence from recurrence series.

Returns Record[]

getCellDetails

Retrieves the start and end time information of the specific cell element.

Parameter Type Description
tdCol Element | Element[] Accepts the single or collection of elements.

Returns CellClickEventArgs

getCurrentViewDates

Retrieves the dates that lies on active view of Schedule.

Returns Date[]

getCurrentViewEvents

Retrieves the events that lies on the current date range of the active view of Schedule.

Returns Record[]

getCurrentViewIndex

Return the current view Index.

Returns number

getDateRangeText

Retrieves a formatted string representing the date range of the given date collection.

Parameter Type Description
dates Date[] An array of Date objects representing the date range.

Returns string

getDeletedOccurrences

Get deleted occurrences from given recurrence series.

Parameter Type Description
recurrenceData string | number | Record Accepts the parent ID of the event object or parent event object

Returns Record[]

getEventDetails

To retrieve the appointment object from element.

Parameter Type Description
element Element Denotes the event UI element on the Schedule.

Returns Record

getEventMaxID

Get the maximum id of an event.

Returns number | string

getEvents

Retrieves the entire collection of events bound to the Schedule.

Parameter Type Description
startDate (optional) Date Accepts the start date.
endDate (optional) Date Accepts te end date.
includeOccurrences (optional) boolean Accepts the boolean value to process the occurrence from recurrence series.

Returns Record[]

getIndexFromResourceId

Select the resources to the based on id.

Parameter Type Description
id string | number id of the resource defined in resources collection.
name (optional) string Name of the resource defined in resources collection.

Returns number

getOccurrencesByID

Retrieves the occurrences of a single recurrence event based on the provided parent ID.

Parameter Type Description
eventID number | string ID of the parent recurrence data from which the occurrences are fetched.

Returns Record[]

getOccurrencesByRange

Retrieves all the occurrences that lies between the specific start and end time range.

Parameter Type Description
startTime Date Denotes the start time range.
endTime Date Denotes the end time range.

Returns Record[]

getResourceCollections

To get the resource collection

Returns ResourcesModel[]

getResourcesByIndex

Retrieves the resource details based on the provided resource index.

Parameter Type Description
index number index of the resources at the last level.

Returns ResourceDetails

getSelectedElements

Retrieves the selected cell elements.

Returns Element[]

getViewDates

Retrieves an array of dates based on the specified date collection direction.

Parameter Type Description
type (optional) NavigationDirection The direction for date collection. Options are:
- ‘Previous’: Returns the previous date range collection from the current rendered date.
- ‘Next’: Returns the next date range collection from the current rendered date.
- ‘Current’: Returns the current rendered date collection.

Returns Date[]

hideSpinner

When the spinner is shown manually using showSpinner method, it can be hidden using this hideSpinner method.

Returns void

importICalendar

Imports the events from an .ics file downloaded from any of the calendars like Google or Outlook into the Scheduler. This method accepts the blob object or string format of an .ics file to be imported as a mandatory argument.

Parameter Type Description
fileContent Blob | string Accepts the file object or string format of an .ics file.

Returns void

isSlotAvailable

To check whether the given time range slots are available for event creation or already occupied by other events. This method currently focuses on validating appointments within the current view date range. However, it does not extend this availability check to recurrence occurrences outside of the current date range.

Parameter Type Description
startTime Date | Record Denotes the start time of the slot.
endTime (optional) Date Denotes the end time of the slot.
groupIndex (optional) number Defines the resource index from last level.

Returns boolean

openEditor

To manually open the event editor on specific time or on certain events.

Parameter Type Description
data Record It can be either cell data or event data.
action CurrentAction Defines the action for which the editor needs to be opened such as either for new event creation or
for editing of existing events. The applicable action names that can be used here are Add, Save, EditOccurrence
and EditSeries.
isEventData (optional) boolean It allows to decide whether the editor needs to be opened with the clicked cell details or with the
passed event details.
repeatType (optional) number It opens the editor with the recurrence options based on the provided repeat type.

Returns void

openOverlapAlert

To manually open the overlap validation Alert.

Parameter Type Description
args PopupOpenEventArgs The arguments for opening the popup.

Returns void

openQuickInfoPopup

To manually open the quick info popup based on cell or event details.

Parameter Type Description
data Record Defines the cell or event data. If the data contains valid ID, it will open event quick info popup,
otherwise cell quick info popup displayed.

Returns void

paste

Method to create a paste event with clipboard data

Parameter Type Description
targetElement HTMLElement Accepts HTMLElement

Returns void

print

Method allows to print the scheduler.

Parameter Type Description
printOptions (optional) ScheduleModel The export options to be set before start with exporting
the Scheduler events to the print window.

Returns void

refreshEvents

Refreshes the event dataSource. This method may be useful when the events alone in the schedule needs to be re-rendered.

Parameter Type Description
isRemoteRefresh (optional) boolean Accepts the boolean to refresh data from remote or local

Returns void

refreshLayout

Refreshes the Schedule layout without re-render.

Returns void

refreshTemplates

Method to refresh the given Schedule templates

Parameter Type Description
templateName (optional) string Accepts the template name

Returns void

removeResource

Removes the specified resource.

Parameter Type Description
resourceId string | string[] | number | number[] Specifies the resource id to be removed.
name string Specifies the resource name from which the id should be referred.

Returns void

resetWorkHours

Removes or resets different working hours on the required working days by accepting the required start and end time as well as the date collection as its parameters. if no parameters has been passed to this function, it will remove all the work hours.

Parameter Type Description
dates (optional) Date[] Collection of dates on which the given start and end hour range need to be applied.
start (optional) string Defines the work start hour.
end (optional) string Defines the work end hour.
groupIndex (optional) number Defines the resource index from last level.

Returns void

saveEvent

Updates the changes made in the event object by passing it as an parameter into the dataSource.

Parameter Type Description
data Record | Record[] Single or collection of event objects to be saved into Schedule.
currentAction (optional) CurrentAction Denotes the action that takes place either for editing occurrence or series.
The valid current action names are EditOccurrence or EditSeries.

Returns void

scrollTo

Scrolls the Schedule content area to the specified time.

Parameter Type Description
hour string Accepts the time value in the skeleton format of ‘Hm’.
scrollDate (optional) Date Accepts the date object value.

Returns void

scrollToResource

This method allows scroll to the position of the any resources that available on the scheduler. This method is applicable for without Agenda and Month agenda views of the schedule.

Parameter Type Description
resourceId string | number Accepts the resource id in either string or number type
groupName (optional) string Accepts the name of the resource collection

Returns void

selectResourceByIndex

Select the resource based on group index in mobile mode.

Parameter Type Description
groupIndex number Defines the resource index based on last level.

Returns void

setRecurrenceEditor

Set the recurrence editor instance from custom editor template.

Parameter Type Description
recurrenceEditor RecurrenceEditor instance has passed to fetch the instance in event window.

Returns void

setResourceCollections

To set the resource collection

Parameter Type Description
resourceCol ResourcesModel[] Accepts the resource collections in ResourcesModel type
isEventDataRefresh (optional) boolean Accepts the boolean to refresh the appointment data source from remote or local

Returns void

setWorkHours

Sets different working hours on the required working days by accepting the required start and end time as well as the date collection as its parameters.

Parameter Type Description
dates Date[] Collection of dates on which the given start and end hour range needs to be applied.
start string Defines the work start hour.
end string Defines the work end hour.
groupIndex (optional) number Defines the resource index from last level.

Returns void

showSpinner

Allows to show the spinner on schedule at the required scenarios.

Returns void

Events

actionBegin

EmitType<ActionEventArgs>

Triggers on beginning of every scheduler action.

actionComplete

EmitType<ActionEventArgs>

Triggers on successful completion of the scheduler actions.

actionFailure

EmitType<ActionEventArgs>

Triggers when a scheduler action gets failed or interrupted and an error information will be returned.

beforePaste

EmitType<BeforePasteEventArgs>

Triggers once when pasting an event on the scheduler.

beforePrint

EmitType<BeforePrintEventArgs>

Triggers when the print event is called.

cellClick

EmitType<CellClickEventArgs>

Triggers when the scheduler cells are single clicked or on single tap on the same cells in mobile devices.

cellDoubleClick

EmitType<CellClickEventArgs>

Triggers when the scheduler cells are double clicked.

created

EmitType<Record>

Triggers after the scheduler component is created.

dataBinding

EmitType<ReturnType>

Triggers before the data binds to the scheduler.

dataBound

EmitType<ReturnType>

Triggers once the event data is bound to the scheduler.

destroyed

EmitType<Record>

Triggers when the scheduler component is destroyed.

drag

EmitType<DragEventArgs>

Triggers when an appointment is being in a dragged state.

dragStart

EmitType<DragEventArgs>

Triggers when an appointment is started to drag.

dragStop

EmitType<DragEventArgs>

Triggers when the dragging of appointment is stopped.

eventClick

EmitType<EventClickArgs>

Triggers when the events are single clicked or on single tapping the events on the mobile devices.

eventDoubleClick

EmitType<EventClickArgs>

Triggers when the events are double clicked or on double tapping the events on the desktop devices.

eventRendered

EmitType<EventRenderedArgs>

Triggers before each of the event getting rendered on the scheduler user interface.

excelExport

EmitType<ExcelExportEventArgs>

Triggers before the Excel export process begins.

hover

EmitType<HoverEventArgs>

Triggers when the scheduler elements are hovered.

moreEventsClick

EmitType<MoreEventsClickArgs>

Triggers when the more events indicator are clicked.

Triggers before the date or view navigation takes place on scheduler.

popupClose

EmitType<PopupCloseEventArgs>

Triggers before any of the scheduler popups close on the page.

popupOpen

EmitType<PopupOpenEventArgs>

Triggers before any of the scheduler popups opens on the page.

renderCell

EmitType<RenderCellEventArgs>

Triggers before each element of the schedule rendering on the page.

resizeStart

EmitType<ResizeEventArgs>

Triggers when an appointment is started to resize.

resizeStop

EmitType<ResizeEventArgs>

Triggers when the resizing of appointment is stopped.

resizing

EmitType<ResizeEventArgs>

Triggers when an appointment is being in a resizing action.

select

EmitType<SelectEventArgs>

Triggers when multiple cells or events are selected on the Scheduler.

tooltipOpen

EmitType<TooltipOpenEventArgs>

Triggers before the tooltip is rendered.

virtualScrollStart

EmitType<ScrollEventArgs>

Triggers when the scroll action is started. This event triggers only when allowVirtualScrolling or enableLazyLoading properties are enabled along with resource grouping.

virtualScrollStop

EmitType<ScrollEventArgs>

Triggers when the scroll action is stopped. This event triggers only when allowVirtualScrolling or enableLazyLoading properties are enabled along with resource grouping.

Contents
Contents

Search results

ScheduleComponent

ej-schedule represents the VueJS Schedule Component.

<ejs-schedule></ejs-schedule>

Properties

agendaDaysCount

number

Sets the number of days to be displayed by default in Agenda View and in case of virtual scrolling, the number of days will be fetched on each scroll-end based on this count.

<template>
  <ejs-schedule currentView="Agenda" agendaDaysCount="2"></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return {};
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to 7

allowClipboard

boolean

Enables clipboard functionality for appointments, allowing them to be copied using keyboard shortcuts and pasted onto the Scheduler. When set to true, users can use keyboard shortcuts to cut, copy appointments and paste them into different time slots or calendars.

Defaults to false

allowDragAndDrop

boolean

When set to true, allows the appointments to move over the time slots. When an appointment is dragged, both its start and end time tends to change simultaneously allowing it to reschedule the appointment on some other time.

Defaults to true

allowInline

boolean

This property helps user to add/edit the event in inline. By default, it is set to false.

Defaults to false

allowKeyboardInteraction

boolean

When set to true, allows the keyboard interaction to take place on Schedule.

Defaults to true

allowMultiCellSelection

boolean

This property helps user to allow/prevent the selection of multiple cells. By default, it is set to true.

Defaults to true

allowMultiDrag

boolean

This property helps to drag the multiple selected events. By default, it is set to false.

Defaults to false

allowMultiRowSelection

boolean

This property helps user to allow/prevent the selection of multiple days(rows). By default, it is set to true.

Defaults to true

allowOverlap

boolean

Specifies whether overlapping appointments are allowed within the same time slot in the Scheduler.

Defaults to true

allowResizing

boolean

When set to true, allows the resizing of appointments. It allows the rescheduling of appointments either by changing the start or end time by dragging the event resize handlers.

Defaults to true

allowSwiping

boolean

Defines whether to enable date navigations via swipe in touch devices or not.

Defaults to true

calendarMode

CalendarType

It allows the Scheduler to display in other calendar modes. By default, Scheduler is displayed in Gregorian calendar mode.

<template>
  <ejs-schedule calendarMode="Islamic"></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return { };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

To change the mode, you can set either Gregorian or Islamic as a value to this calendarMode property.

Defaults to ‘Gregorian’

cellHeaderTemplate

string | function

It accepts either the string or HTMLElement as template design content and parse it appropriately before displaying it onto the month date cells. This template is only applicable for month view day cells.

<template>
  <ejs-schedule :cellHeaderTemplate="cellHeaderTemplate"></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import { Internationalization } from "@syncfusion/ej2-base";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);
let instance = new Internationalization();
var cellHeaderTemplateVue = Vue.component("cellHeaderTemplate", {
  template: `<div class="templatewrap"><div v-html=getDate(data.date)></div></div>`,
  data() {
    return {
      data: {}
    };
  },
  methods: {
    getDate: function(date) {
      return instance.formatDate(date, { skeleton: "Ed" });
    }
  }
});
export default Vue.extend({
  data: function() {
    return {
      cellHeaderTemplate: function(e) {
        return {
          template: cellHeaderTemplateVue
        };
      }
    };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to null

cellTemplate

string | function

The template option which is used to render the customized work cells on the Schedule. Here, the template accepts either the string or HTMLElement as template design and then the parsed design is displayed onto the work cells. The fields accessible via template are as follows.

  • date: Returns the date of the cell.
  • groupIndex: Returns the group index of the cell.
  • type: Returns the type of the work cell. Refer to the below code snippet.
<template>
  <ejs-schedule :cellTemplate="cellTemplate"></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

var cellTemplateVue = Vue.component("cellTemplate", {
  template: `<div class="templatewrap"><div v-if="data.type==='workCells'"><div v-html=getWorkCellText(data.date)></div></div><div v-else-if="data.type==='monthCells'"><div v-html=getMonthCellText(data.date)></div></div></div>`,
  data() {
    return {
      data: {}
    };
  },
  methods: {
    getWorkCellText: function(date) {
      let weekEnds = [0, 6];
      if (weekEnds.indexOf(date.getDay()) >= 0) {
        return "<img src='https://ej2.syncfusion.com/demos/src/schedule/images/newyear.svg' style='width:80%;height:80%'/>";
      }
      return "";
    },
    getMonthCellText: function(date) {
      if (date.getMonth() === 10 && date.getDate() === 23) {
        return '<img src= "https://ej2.syncfusion.com/demos/src/schedule/images/birthday.svg" style="width:80%;height:80%"/>';
      } else if (date.getMonth() === 11 && date.getDate() === 9) {
        return '<img src= "https://ej2.syncfusion.com/demos/src/schedule/images/get-together.svg" style="width:80%;height:80%"/>';
      }
      return "";
    }
  }
});
export default Vue.extend({
  data: function() {
    return {
      cellTemplate: function(e) {
        return {
          template: cellTemplateVue
        };
      }
    };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to null

cssClass

string

It is used to customize the Schedule which accepts custom CSS class names that defines specific user-defined styles and themes to be applied on the Schedule element.

<template>
  <ejs-schedule cssClass="cell-dimension"></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return { };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to null

currentView

View

To set the active view on scheduler, the currentView property can be used and it usually accepts either of the following available view options. The view option specified in this property will be initially loaded on the schedule.

  • Day: Denotes Day view of the scheduler.
  • Week: Denotes Week view of the scheduler.
  • WorkWeek: Denotes Work Week view of the scheduler.
  • Month: Denotes Month view of the scheduler.
  • Year: Denotes Year view of the scheduler.
  • Agenda: Denotes Agenda view of the scheduler.
  • MonthAgenda: Denotes Month Agenda view of the scheduler.
  • TimelineDay: Denotes Timeline Day view of the scheduler.
  • TimelineWeek: Denotes Timeline Week view of the scheduler.
  • TimelineWorkWeek: Denotes Timeline Work Week view of the scheduler.
  • TimelineMonth: Denotes Timeline Month view of the scheduler.
  • TimelineYear: Denotes Timeline Year view of the scheduler.
<template>
  <ejs-schedule currentView="Day"></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return { };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to ‘Week’

dateFormat

string

By default, Schedule follows the date-format as per the default culture assigned to it. It is also possible to manually set specific date format by using the dateFormat property.

<template>
  <ejs-schedule dateFormat='dd-MMM-yyyy'></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return { };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

The format of the date range label in the header bar depends on the dateFormat value or else based on the locale assigned to the Schedule.

Defaults to null

dateHeaderTemplate

string | function

It accepts either the string or HTMLElement as template design content and parse it appropriately before displaying it onto the date header cells. The field that can be accessed via this template is date.

<template>
  <ejs-schedule :dateHeaderTemplate="dateHeaderTemplate"></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import { Internationalization } from "@syncfusion/ej2-base";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);
let instance = new Internationalization();
var dateHeaderTemplateVue = Vue.component("dateHeaderTemplate", {
  template: `<div class="templatewrap"><div v-html=getDateHeaderText(data.date)></div></div>`,
  data() {
    return {
      data: {}
    };
  },
  methods: {
    getDateHeaderText: function(date) {
      return instance.formatDate(date, { skeleton: "Ed" });
    }
  }
});
export default Vue.extend({
  data: function() {
    return {
      dateHeaderTemplate: function(e) {
        return {
          template: dateHeaderTemplateVue
        };
      }
    };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to null

dateRangeTemplate

string | function

It accepts either the string or HTMLElement as template design content and parse it appropriately before displaying it onto the header date range.

Defaults to null

dayHeaderTemplate

string | function

It accepts either the string or HTMLElement as template design content and parse it appropriately before displaying it onto the day header cells. This template is only applicable for year view header cells.

Defaults to null

editorFooterTemplate

string | function

The template option to render the customized footer of the editor window.

Defaults to null

editorHeaderTemplate

string | function

The template option to render the customized header of the editor window.

Defaults to null

editorTemplate

string | function

The template option to render the customized editor window. The form elements defined within this template should be accompanied with e-field class, so as to fetch and process it from internally.

<template>
  <ejs-schedule :editorTemplate="editorTemplate" :popupOpen="onPopupOpen"></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import { DropDownList } from "@syncfusion/ej2-dropdowns";
import { DateTimePicker } from "@syncfusion/ej2-calendars";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);
var editorTemplateVue = Vue.component("editorTemplate", {
  template: `<table class="custom-event-editor" width="100%" cellpadding="5"><tbody><tr>
  <td class="e-textlabel">Summary</td><td colspan="4"><input id="Subject" class="e-field e-input" type="text" value="" name="Subject" style="width: 100%" /></td></tr><tr><td class="e-textlabel">Status</td><td colspan="4"><input type="text" id="EventType" name="EventType" class="e-field" style="width: 100%" /></td></tr><tr><td class="e-textlabel">From</td><td colspan="4"><input id="StartTime" class="e-field" type="text" name="StartTime" /></td></tr><tr>
  <td class="e-textlabel">To</td><td colspan="4"><input id="EndTime" class="e-field" type="text" name="EndTime" /></td></tr><tr><td class="e-textlabel">Reason</td><td colspan="4">
  <textarea id="Description" class="e-field e-input" name="Description" rows="3" cols="50"                 style="width: 100%; height: 60px !important; resize: vertical"></textarea></td></tr></tbody></table>`,
  data() {
    return {
      data: {}
    };
  }
});
export default Vue.extend({
  data: function() {
    return {
      editorTemplate: function(e) {
        return {
          template: editorTemplateVue
        };
      }
    };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {
    onPopupOpen: function(args) {
      if (args.type === "Editor") {
        let statusElement = args.element.querySelector("#EventType");
        if (!statusElement.classList.contains("e-dropdownlist")) {
          let dropDownListObject = new DropDownList({
            placeholder: "Choose status",
            value: statusElement.value,
            dataSource: ["New", "Requested", "Confirmed"]
          });
          dropDownListObject.appendTo(statusElement);
          statusElement.setAttribute("name", "EventType");
        }
        let startElement = args.element.querySelector("#StartTime");
        if (!startElement.classList.contains("e-datetimepicker")) {
          new DateTimePicker(
            { value: new Date(startElement.value) || new Date() },
            startElement
          );
        }
        let endElement = args.element.querySelector("#EndTime");
        if (!endElement.classList.contains("e-datetimepicker")) {
          new DateTimePicker(
            { value: new Date(endElement.value) || new Date() },
            endElement
          );
        }
      }
    }
  }
});
</script>

Defaults to null

enableAdaptiveUI

boolean

When set to true, the header view navigations are listed under the popup and if we enable resource grouping, the compact view will be enabled.

Defaults to false

enableAllDayScroll

boolean

When set to true, If valid, the scroll on the all day row is activated when the all day row height reaches the max height when the all day row is expanded.

Defaults to false

enableHtmlSanitizer

boolean

Specifies whether to enable the rendering of untrusted HTML values in the Schedule component. When this property is enabled, the component will sanitize any suspected untrusted strings and scripts before rendering them.

Defaults to true

enablePersistence

boolean

Enable or disable persisting component’s state between page reloads.

Defaults to false

enableRecurrenceValidation

boolean

The recurrence validation will be done by default. When this property is set to false, the recurrence validation will be skipped.

Defaults to true

enableRtl

boolean

Enable or disable rendering component in right to left direction.

Defaults to false

endHour

string

It is used to specify the end hour, at which the Schedule ends. It too accepts the time string in a short skeleton format.

<template>
  <ejs-schedule endHour='18:00'></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return { };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to ‘24:00’

eventDragArea

string

It enables the external drag and drop support for appointments on scheduler, to be able to move them out of the scheduler layout. When the drag area is explicitly set with specific DOM element name, the appointments can be dragged anywhere within the specified drag area location.

<template>
  <ejs-schedule eventDragArea='body'></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return { };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to null

eventSettings

EventSettingsModel

Complete set of settings related to Schedule events to bind it to local or remote dataSource, map applicable database fields and other validation to be carried out on the available fields.

<template>
  <ejs-schedule :eventSettings="eventSettings"></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

let data = [
  {
    Id: 1,
    Subject: "Paris",
    StartTime: new Date(2023, 1, 15, 10, 0),
    EndTime: new Date(2023, 1, 15, 12, 30)
  }
];
export default Vue.extend({
  data: function() {
    return {
      eventSettings: { dataSource: data }
    };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to null

firstDayOfWeek

number

This option allows the user to set the first day of a week on Schedule. It should be based on the locale set to it and each culture defines its own first day of week values. If needed, the user can set it manually on his own by defining the value through this property. It usually accepts the integer values, whereby 0 is always denoted as Sunday, 1 as Monday and so on.

<template>
  <ejs-schedule :firstDayOfWeek="firstDayOfWeek"></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return {
      firstDayOfWeek: 2
    };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to 0

firstMonthOfYear

number

This property helps render the year view customized months. By default, it is set to 0.

<template>
  <ejs-schedule :firstMonthOfYear="firstMonthOfYear">
     <e-views>
      <e-view option='Year'></e-view>
      <e-view option='TimelineYear'></e-view>
     </e-views>
  </ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  TimelineYear,
  Year,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return {
      firstMonthOfYear: 2
    };
  },
  provide: {
    schedule: [Year, TimelineYear, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to 0

group

GroupModel

Allows defining the group related settings of multiple resources. When this property is non-empty, it means that the resources will be grouped on the schedule layout based on the provided resource names.

<template>
  <ejs-schedule id="Schedule" :group="group">
    <e-resources>
      <e-resource
        field="AirlineId"
        title="Airline Name"
        name="Airlines"
        :allowMultiple="allowMultiple"
        :dataSource="resourceDataSource"
        textField="AirlineName"
        idField="AirlineId"
        colorField="AirlineColor"
      ></e-resource>
    </e-resources>
  </ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return {
      allowMultiple: true,
      resourceDataSource: [
        { AirlineName: "Airways 1", AirlineId: 1, AirlineColor: "#EA7A57" },
        { AirlineName: "Airways 2", AirlineId: 2, AirlineColor: "#357cd2" },
        { AirlineName: "Airways 3", AirlineId: 3, AirlineColor: "#7fa900" }
      ],
      group: { resources: ["Airlines"] }
    };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to {}

headerIndentTemplate

string | function

Template option to customize the header indent bar. Here, the template accepts either the string or HTMLElement as template design and then the parsed design is displayed onto the header indent cell. Refer to the below code snippet.

<template>
  <ejs-schedule id="Schedule" :headerIndentTemplate="headerIndentTemplate">
  </ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);
var headerIndentTemplateVue = Vue.component("headerTemplate", {
  template: `<div class='template-wrap' v-if="data.className[0] == 'e-header-cells'">Template</div>`,
  data() {
    return {
      data: {}
    };
  }
});
export default Vue.extend({
  data: function() {
    return {
      headerIndentTemplate: function() {
        return {
          template: headerIndentTemplateVue
        };
      }
    };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to null

headerRows

HeaderRowsModel[]

Allows defining the collection of custom header rows to display the year, month, week, date and hour label as an individual row on the timeline view of the scheduler.

<template>
  <ejs-schedule :views="views" :headerRows="headerRows"></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import { SchedulePlugin, TimelineViews } from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return {
      views: ["TimelineWeek"],
      headerRows: [
        { option: "Year" },
        { option: "Month" },
        { option: "Week" },
        { option: "Date" },
        { option: "Hour" }
      ]
    };
  },
  provide: {
    schedule: [TimelineViews]
  },
  methods: {}
});
</script>

Defaults to []

height

string | number

Sets the height of the Schedule component, accepting both string and number values.

<template>
  <ejs-schedule height='550px'></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return { };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

The string type includes either pixel or percentage values. When height is set with specific pixel value, then the Schedule will be rendered to that specified space. In case, if auto value is set, then the height of the Schedule gets auto-adjusted within the given container.

Defaults to ‘auto’

hideEmptyAgendaDays

boolean

The days which does not has even a single event to display will be hidden from the UI of Agenda View by default. When this property is set to false, the empty dates will also be displayed on the Schedule.

Defaults to true

locale

string

Overrides the global culture and localization value for this component. Default global culture is ‘en-US’.

Defaults to

maxDate

Date

To define the maximum date on the Schedule, maxDate property can be defined. Usually, it defaults to the new Date(2099, 11, 31).

<template>
  <ejs-schedule :maxDate="maxDate"></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import { SchedulePlugin, Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return {
      maxDate:new Date(2021, 0, 1)
    };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to new Date(2099, 11, 31)

minDate

Date

To define the minimum date on the Schedule, minDate property can be defined. Usually, it defaults to the new Date(1900, 0, 1).

<template>
  <ejs-schedule :minDate="minDate"></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import { SchedulePlugin, Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return {
      minDate:new Date(2020, 6, 1)
    };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to new Date(1900, 0, 1)

monthHeaderTemplate

string | function

It accepts either the string or HTMLElement as template design content and parse it appropriately before displaying it onto the month header cells. This template is only applicable for year view header cells.

Defaults to null

monthsCount

number

This option allows the user to set the number of months count to be displayed on the Schedule.

<template>
  <ejs-schedule :monthsCount="monthsCount">
     <e-views>
      <e-view option='Year'></e-view>
      <e-view option='TimelineYear'></e-view>
     </e-views>
  </ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  TimelineYear,
  Year,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return {
      monthsCount:16
    };
  },
  provide: {
    schedule: [Year, TimelineYear, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to 12

overscanCount

number

Specifies the number of additional rows or columns to render outside the visible area during virtual scrolling. This property helps in achieving smoother scrolling by pre-loading data just outside the visible region.

Defaults to 3

quickInfoOnSelectionEnd

boolean

This property helps to show quick popup after multiple cell selection. By default, it is set to false.

Defaults to false

quickInfoTemplates

QuickInfoTemplatesModel

The template option to customize the quick window. The three sections of the quick popup whereas the header, content, and footer can be easily customized with individual template option.

<template>
  <ejs-schedule :quickInfoTemplates="quickInfoTemplates"></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);
var headerTemplateVue = Vue.component("headerTemplate", {
  template: `<div><div v-if= "data.elementType === 'cell' "><div class="e-cell-header">
        <div class="e-header-icon-wrapper"><button class="e-close" title="Close"></button></div></div></div>
        <div v-else><div class="e-event-header"><div class="e-header-icon-wrapper"><button class="e-close" title="CLOSE"></button></div></div></div></div>`,
  data() {
    return {
      data: {}
    };
  }
});

var contentTemplateVue = Vue.component("contentTemplate", {
  template: `<div><div v-if= "data.elementType === 'cell' "><div class="e-cell-content e-template">
        <form class="e-schedule-form"><div><input class="subject e-field" type="text" name="Subject" placeholder="Title"></div><div><input class="location e-field" type="text" name="Location" placeholder="Location"></div></form></div></div><div v-else><div class="e-event-content e-template">
        <div class="e-subject-wrap"><div><div v-if="data.Subject !== undefined"><div class="subject">{{data.Subject}}</div></div></div><div><div v-if="data.Location !== undefined"><div class="location">{{data.Location}}</div></div></div><div><div v-if="data.Description !== undefined"><div class="description">{{data.Description}}</div></div></div></div></div></div></div>`,
  data() {
    return {
      data: {}
    };
  }
});

var footerTemplateVue = Vue.component("footerTemplate", {
  template: `<div><div v-if= "data.elementType === 'cell' "><div class="e-cell-footer">
        <button class="e-event-details" title="Extra Details">Extra Details</button>
        <button class="e-event-create" title="Add">Add</button></div></div>
        <div v-else><div class="e-event-footer"><button class="e-event-edit" title="Edit">Edit</button>
        <button class="e-event-delete" title="Delete">Delete</button></div></div></div>`,
  data() {
    return {
      data: {}
    };
  }
});
export default Vue.extend({
  data: function() {
    return {
      quickInfoTemplates: {
        header: function(e) {
          return {
            template: headerTemplateVue
          };
        },
        content: function(e) {
          return {
            template: contentTemplateVue
          };
        },
        footer: function(e) {
          return {
            template: footerTemplateVue
          };
        }
      }
    };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to null

readonly

boolean

When set to true, makes the Schedule to render in a read only mode. No CRUD actions will be allowed at this time.

Defaults to false

resourceHeaderTemplate

string | function

Template option to customize the resource header bar. Here, the template accepts either the string or HTMLElement as template design and then the parsed design is displayed onto the resource header cells. The following can be accessible via template.

  • resource - All the resource fields.
  • resourceData - Object collection of current resource. Refer to the below code snippet.
<template>
  <ejs-schedule :group="group" :resourceHeaderTemplate="resourceHeaderTemplate">
    <e-resources>
      <e-resource
        field="DoctorId"
        title="Doctor Name"
        name="Doctors"
        :dataSource="ownerDataSource"
        textField="text"
        idField="id"
        colorField="color"
      ></e-resource>
    </e-resources>
  </ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);
var resourceHeaderTemplateVue = Vue.component("headerTemplate", {
  template: `<div class='template-wrap'><div class="resource-details"><div class="resource-name">{{data.resourceData.text}}</div><div class="resource-designation">{{data.resourceData.designation}}</div></div></div>`,
  data() {
    return {
      data: {}
    };
  }
});
export default Vue.extend({
  data: function() {
    return {
      group: {
        resources: ["Doctors"]
      },
      ownerDataSource: [
        {
          text: "Will Smith",
          id: 1,
          color: "#ea7a57",
          designation: "Cardioligst"
        },
        { text: "Alice", id: 2, color: "#7fa900", designation: "Neurologist" },
        {
          text: "Robson",
          id: 3,
          color: "#7fa900",
          designation: "Orthopedic Surgeon"
        }
      ],
      resourceHeaderTemplate: function(e) {
        return {
          template: resourceHeaderTemplateVue
        };
      }
    };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to null

resources

ResourcesModel[]

Allows defining the collection of resources to be displayed on the Schedule. The resource collection needs to be defined with unique resource names to identify it along with the respective dataSource and field mapping options.

<template>
  <ejs-schedule :group="group">
    <e-resources>
      <e-resource
        field="AirlineId"
        title="Airline Name"
        name="Airlines"
        :allowMultiple="allowMultiple"
        :dataSource="resourceDataSource"
        textField="AirlineName"
        idField="AirlineId"
        colorField="AirlineColor"
      ></e-resource>
    </e-resources>
  </ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return {
      allowMultiple: true,
      resourceDataSource: [
        { AirlineName: "Airways 1", AirlineId: 1, AirlineColor: "#EA7A57" },
        { AirlineName: "Airways 2", AirlineId: 2, AirlineColor: "#357cd2" },
        { AirlineName: "Airways 3", AirlineId: 3, AirlineColor: "#7fa900" }
      ],
      group: { resources: ["Airlines"] }
    };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to []

rowAutoHeight

boolean

when set to true, allows the height of the work-cells to adjust automatically based on the number of appointments present in those time ranges.

Defaults to false

selectedDate

Date

To mark the active (current) date on the Schedule, selectedDate property can be defined. Usually, it defaults to the current System date.

<template>
  <ejs-schedule :selectedDate="selectedDate"></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return {
      selectedDate: new Date(2023, 3, 4)
    };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to ‘new Date()’

showHeaderBar

boolean

When set to false, hides the header bar of the Schedule from UI. By default, the header bar holds the date and view navigation options, to which the user can add their own custom items onto it.

Defaults to true

showQuickInfo

boolean

When set to true, displays a quick popup with cell or event details on single clicking over the cells or on events. By default, it is set to true.

Defaults to true

showTimeIndicator

boolean

When set to false, hides the current time indicator from the Schedule. Otherwise, it visually depicts the live current system time appropriately on the user interface.

Defaults to true

showWeekNumber

boolean

When set to true, displays the week number of the current view date range. By default, it is set to false.

Defaults to false

showWeekend

boolean

When set to false, it hides the weekend days of a week from the Schedule. The days which are not defined in the working days collection are usually treated as weekend days. Note: By default, this option is not applicable on Work Week view. For example, if the working days are defined as [1, 2, 3, 4], then the remaining days of that week will be considered as the weekend days and will be hidden on all the views.

Defaults to true

startHour

string

It is used to specify the starting hour, from which the Schedule starts to display. It accepts the time string in a short skeleton format and also, hides the time beyond the specified start time.

<template>
  <ejs-schedule startHour='10:00'></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return { };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to ‘00:00’

timeFormat

string

By default, Schedule follows the time-format as per the default culture assigned to it. It is also possible to manually set specific time format by using the timeFormat property.

Defaults to null

timeScale

TimeScaleModel

Allows to set different time duration on Schedule along with the customized grid count. It also has template option to customize the time slots with required time values in its own format.

<template>
  <ejs-schedule :timeScale="timeScale"></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return {
      timeScale: {
        enable: true,
        interval: 60,
        slotCount: 6
      }
    };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to { enable: true, interval: 60, slotCount: 2, majorSlotTemplate: null, minorSlotTemplate: null }

timezone

string

Schedule will be assigned with specific timezone, so as to display the events in it accordingly. By default, Schedule dates are processed with System timezone, as no timezone will be assigned specifically to the Schedule at the initial time. Whenever the Schedule is bound to remote data services, it is always recommended to set specific timezone to Schedule to make the events on it to display on the same time irrespective of the system timezone. It usually accepts the valid IANA timezone names.

<template>
  <ejs-schedule timezone='UTC'></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return { };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to null

timezoneDataSource

TimezoneFields[]

Allows to define the collection of timezone items in the Schedule. Only the items bound to this property get listed out in the timezone dropdown of the appointment window.

<template>
  <ejs-schedule :eventSettings="eventSettings"></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return {
      timezoneDataSource : [
                    { Value: 'Pacific/Niue', Text: 'Niue' },
                    { Value: 'Pacific/Pago_Pago', Text: 'Pago Pago' },
                    { Value: 'Pacific/Honolulu', Text: 'Hawaii Time' },
                    { Value: 'Pacific/Rarotonga', Text: 'Rarotonga' },
                    { Value: 'Pacific/Tahiti', Text: 'Tahiti' },
                ]
    };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to timezoneData

toolbarItems

ToolbarItemModel[]

To render the custom toolbar items, the toolbarItems property can be used. It contains built-in and custom toolbar items. To avail the built-in toolbar items, the below string values are assigned to the name property of the ToolbarItemModel.

  • Previous: Schedule component navigates to the previous date from the current date.
  • Next: Schedule component navigates to the next date from the current date.
  • Today: Schedule component navigates to the current date from any date.
  • Views: Schedule component render the defined view options in the toolbar. If view option is not defined, then it will render default view options in the Schedule.
  • DateRangeText: Schedule component displays the current date text range.
  • NewEvent: Schedule component render the icon to add a new event.

Defaults to []

views

View[] | ViewsModel[]

This property holds the views collection and its configurations. It accepts either the array of view names or the array of view objects that holds different configurations for each views. By default, Schedule displays all the views namely Day, Week, Work Week, Month and Agenda. Example for array of views:

Example for array of view objects:

Defaults to ’[“Day”, “Week”, “WorkWeek”, “Month”, “Agenda”]’

weekRule

WeekRule

It allows the Scheduler to display week numbers based on following available week options. The week option specified in this property will be initially loaded on the schedule.

  • FirstDay: Denotes that the first week of the year starts on the first day of the year and ends before the following designated first day of the week.
  • FirstFourDayWeek:Denotes that the first week of the year is the first week with four or more days before the designated first day of the week.
  • FirstFullWeek: Denotes that the first week of the year begins on the first occurrence of the designated first day of the week on or after the first day of the year.
<template>
  <ejs-schedule :showWeekNumber="showWeekNumber" :weekRule="weekRule"></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import { SchedulePlugin, Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return {
      showWeekNumber: true,
      weekRule:'FirstFourDayWeek'
    };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to ‘FirstDay’

width

string | number

Sets the width of the Schedule component, accepting both string and number values.

<template>
  <ejs-schedule width="100%"></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return { };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

The string value can be either pixel or percentage format. When set to auto, the Schedule width gets auto-adjusted and display its content related to the viewable screen size.

Defaults to ‘auto’

workDays

number[]

It is used to set the working days on Schedule. The only days that are defined in this collection will be rendered on the workWeek view whereas on other views, it will display all the usual days and simply highlights the working days with different shade.

<template>
  <ejs-schedule :workDays="workDays"></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return {
      workDays: [1, 3, 5]
    };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to ’[1, 2, 3, 4, 5]’

workHours

WorkHoursModel

The working hours should be highlighted on Schedule with different color shade and an additional option must be provided to highlight it or not. This functionality is handled through workHours property and the start work hour should be 9 AM by default and end work hour should point to 6 PM. The start and end working hours needs to be provided as Time value of short skeleton type.

<template>
  <ejs-schedule :workHours="workHours"></ejs-schedule>
</template>
<style>
</style>
<script>
import Vue from "vue";
import {
  SchedulePlugin,
  Day,
  Week,
  WorkWeek,
  Month,
  Agenda,
  Resize,
  DragAndDrop
} from "@syncfusion/ej2-vue-schedule";

Vue.use(SchedulePlugin);

export default Vue.extend({
  data: function() {
    return {
      workHours: {
        highlight: true,
        start: "11:00",
        end: "20:00"
      }
    };
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda, Resize, DragAndDrop]
  },
  methods: {}
});
</script>

Defaults to { highlight: true, start: ‘09:00’, end: ‘18:00’ }

Methods

addEvent

Adds the newly created event into the Schedule dataSource.

Parameter Type Description
data Record | Record[] Single or collection of event objects to be added into Schedule.

Returns void

addResource

Adds the resources to the specified index.

Parameter Type Description
resources Record | Record[] Accepts the resource data in single or collection of data.
name string Name of the resource defined in resources collection.
index number Index or position where the resource should be added.

Returns void

changeCurrentView

Current View could be change based on the provided parameters.

Parameter Type Description
viewName View Accept the view in the viewCollections.
viewIndex (optional) number Accept the viewIndex in the viewCollections.

Returns void

closeEditor

To manually close the event editor window

Returns void

closeOverlapAlert

To manually close the overlap validation Alert.

Returns void

closeQuickInfoPopup

To manually close the quick info popup

Returns void

closeTooltip

Closes the tooltip. For example, when the context menu is opened for an event, the tooltip can be closed by calling this method.

Returns void

collapseResource

This method allows to collapse the resource that available on the scheduler.

Parameter Type Description
resourceId string | number Accepts the resource id in either string or number type
name string Accepts the name of the resource collection

Returns void

copy

Method to copy events from an HTMLElement or an array of HTMLElements.

Parameter Type Description
elements HTMLElement[] Accepts an array of HTMLElement

Returns void

cut

Method to cut events from an HTMLElement or an array of HTMLElements.

Parameter Type Description
elements HTMLElement[] Accepts an array of HTMLElement

Returns void

deleteEvent

Deletes the events based on the provided ID or event collection in the argument list.

Parameter Type Description
id string | number | Record | Record[] Accepts the ID as string or number type or single or collection of the event object which needs to be removed from the Schedule.
currentAction (optional) CurrentAction Denotes the delete action that takes place either on occurrence or series events.
The valid current action names are Delete, DeleteOccurrence or DeleteSeries.

Returns void

destroy

Destroys the Schedule component.

Returns void

expandResource

This method allows to expand the resource that available on the scheduler.

Parameter Type Description
resourceId string | number Accepts the resource id in either string or number type
name string Accepts the name of the resource collection

Returns void

exportToExcel

Allows the Scheduler events data to be exported as an Excel file either in .xlsx or .csv file formats. By default, the whole event collection bound to the Scheduler gets exported as an Excel file. To export only the specific events of Scheduler, you need to pass the custom data collection as a parameter to this exportToExcel method. This method accepts the export options as arguments such as fileName, exportType, fields, customData, and includeOccurrences. The fileName denotes the name to be given for the exported file and the exportType allows you to set the format of an Excel file to be exported either as .xlsx or .csv. The custom or specific field collection of event dataSource to be exported can be provided through fields option and the custom data collection can be exported by passing them through the customData option. There also exists option to export each individual instances of the recurring events to an Excel file, by setting true or false to the includeOccurrences option, denoting either to include or exclude the occurrences as separate instances on an exported Excel file.

Parameter Type Description
excelExportOptions (optional) ExportOptions The export options to be set before start with exporting the Scheduler events to an Excel file.

Returns void

exportToICalendar

Exports the Scheduler events to a calendar (.ics) file. By default, the calendar is exported with a file name Calendar.ics. To change this file name on export, pass the custom string value as fileName to get the file downloaded with this provided name.

Parameter Type Description
fileName (optional) string Accepts the string value.
customData (optional) Record[] Accepts the collection of objects.

Returns void

generateEventOccurrences

Generates the occurrences of a single recurrence event based on the provided event.

Parameter Type Description
event Record Accepts the parent recurrence event from which the occurrences are generated.
startDate (optional) Date Accepts the start date for the event occurrences. If not provided, the event’s start date will be used.

Returns Record[]

getBlockEvents

Retrieves the entire collection of block events bound to the Schedule.

Parameter Type Description
startDate (optional) Date Accepts the start date.
endDate (optional) Date Accepts te end date.
includeOccurrences (optional) boolean Accepts the boolean value to process the occurrence from recurrence series.

Returns Record[]

getCellDetails

Retrieves the start and end time information of the specific cell element.

Parameter Type Description
tdCol Element | Element[] Accepts the single or collection of elements.

Returns CellClickEventArgs

getCurrentViewDates

Retrieves the dates that lies on active view of Schedule.

Returns Date[]

getCurrentViewEvents

Retrieves the events that lies on the current date range of the active view of Schedule.

Returns Record[]

getCurrentViewIndex

Return the current view Index.

Returns number

getDateRangeText

Retrieves a formatted string representing the date range of the given date collection.

Parameter Type Description
dates Date[] An array of Date objects representing the date range.

Returns string

getDeletedOccurrences

Get deleted occurrences from given recurrence series.

Parameter Type Description
recurrenceData string | number | Record Accepts the parent ID of the event object or parent event object

Returns Record[]

getEventDetails

To retrieve the appointment object from element.

Parameter Type Description
element Element Denotes the event UI element on the Schedule.

Returns Record

getEventMaxID

Get the maximum id of an event.

Returns number | string

getEvents

Retrieves the entire collection of events bound to the Schedule.

Parameter Type Description
startDate (optional) Date Accepts the start date.
endDate (optional) Date Accepts te end date.
includeOccurrences (optional) boolean Accepts the boolean value to process the occurrence from recurrence series.

Returns Record[]

getIndexFromResourceId

Select the resources to the based on id.

Parameter Type Description
id string | number id of the resource defined in resources collection.
name (optional) string Name of the resource defined in resources collection.

Returns number

getOccurrencesByID

Retrieves the occurrences of a single recurrence event based on the provided parent ID.

Parameter Type Description
eventID number | string ID of the parent recurrence data from which the occurrences are fetched.

Returns Record[]

getOccurrencesByRange

Retrieves all the occurrences that lies between the specific start and end time range.

Parameter Type Description
startTime Date Denotes the start time range.
endTime Date Denotes the end time range.

Returns Record[]

getResourceCollections

To get the resource collection

Returns ResourcesModel[]

getResourcesByIndex

Retrieves the resource details based on the provided resource index.

Parameter Type Description
index number index of the resources at the last level.

Returns ResourceDetails

getSelectedElements

Retrieves the selected cell elements.

Returns Element[]

getViewDates

Retrieves an array of dates based on the specified date collection direction.

Parameter Type Description
type (optional) NavigationDirection The direction for date collection. Options are:
- ‘Previous’: Returns the previous date range collection from the current rendered date.
- ‘Next’: Returns the next date range collection from the current rendered date.
- ‘Current’: Returns the current rendered date collection.

Returns Date[]

hideSpinner

When the spinner is shown manually using showSpinner method, it can be hidden using this hideSpinner method.

Returns void

importICalendar

Imports the events from an .ics file downloaded from any of the calendars like Google or Outlook into the Scheduler. This method accepts the blob object or string format of an .ics file to be imported as a mandatory argument.

Parameter Type Description
fileContent Blob | string Accepts the file object or string format of an .ics file.

Returns void

isSlotAvailable

To check whether the given time range slots are available for event creation or already occupied by other events. This method currently focuses on validating appointments within the current view date range. However, it does not extend this availability check to recurrence occurrences outside of the current date range.

Parameter Type Description
startTime Date | Record Denotes the start time of the slot.
endTime (optional) Date Denotes the end time of the slot.
groupIndex (optional) number Defines the resource index from last level.

Returns boolean

openEditor

To manually open the event editor on specific time or on certain events.

Parameter Type Description
data Record It can be either cell data or event data.
action CurrentAction Defines the action for which the editor needs to be opened such as either for new event creation or
for editing of existing events. The applicable action names that can be used here are Add, Save, EditOccurrence
and EditSeries.
isEventData (optional) boolean It allows to decide whether the editor needs to be opened with the clicked cell details or with the
passed event details.
repeatType (optional) number It opens the editor with the recurrence options based on the provided repeat type.

Returns void

openOverlapAlert

To manually open the overlap validation Alert.

Parameter Type Description
args PopupOpenEventArgs The arguments for opening the popup.

Returns void

openQuickInfoPopup

To manually open the quick info popup based on cell or event details.

Parameter Type Description
data Record Defines the cell or event data. If the data contains valid ID, it will open event quick info popup,
otherwise cell quick info popup displayed.

Returns void

paste

Method to create a paste event with clipboard data

Parameter Type Description
targetElement HTMLElement Accepts HTMLElement

Returns void

print

Method allows to print the scheduler.

Parameter Type Description
printOptions (optional) ScheduleModel The export options to be set before start with exporting
the Scheduler events to the print window.

Returns void

refreshEvents

Refreshes the event dataSource. This method may be useful when the events alone in the schedule needs to be re-rendered.

Parameter Type Description
isRemoteRefresh (optional) boolean Accepts the boolean to refresh data from remote or local

Returns void

refreshLayout

Refreshes the Schedule layout without re-render.

Returns void

refreshTemplates

Method to refresh the given Schedule templates

Parameter Type Description
templateName (optional) string Accepts the template name

Returns void

removeResource

Removes the specified resource.

Parameter Type Description
resourceId string | string[] | number | number[] Specifies the resource id to be removed.
name string Specifies the resource name from which the id should be referred.

Returns void

resetWorkHours

Removes or resets different working hours on the required working days by accepting the required start and end time as well as the date collection as its parameters. if no parameters has been passed to this function, it will remove all the work hours.

Parameter Type Description
dates (optional) Date[] Collection of dates on which the given start and end hour range need to be applied.
start (optional) string Defines the work start hour.
end (optional) string Defines the work end hour.
groupIndex (optional) number Defines the resource index from last level.

Returns void

saveEvent

Updates the changes made in the event object by passing it as an parameter into the dataSource.

Parameter Type Description
data Record | Record[] Single or collection of event objects to be saved into Schedule.
currentAction (optional) CurrentAction Denotes the action that takes place either for editing occurrence or series.
The valid current action names are EditOccurrence or EditSeries.

Returns void

scrollTo

Scrolls the Schedule content area to the specified time.

Parameter Type Description
hour string Accepts the time value in the skeleton format of ‘Hm’.
scrollDate (optional) Date Accepts the date object value.

Returns void

scrollToResource

This method allows scroll to the position of the any resources that available on the scheduler. This method is applicable for without Agenda and Month agenda views of the schedule.

Parameter Type Description
resourceId string | number Accepts the resource id in either string or number type
groupName (optional) string Accepts the name of the resource collection

Returns void

selectResourceByIndex

Select the resource based on group index in mobile mode.

Parameter Type Description
groupIndex number Defines the resource index based on last level.

Returns void

setRecurrenceEditor

Set the recurrence editor instance from custom editor template.

Parameter Type Description
recurrenceEditor RecurrenceEditor instance has passed to fetch the instance in event window.

Returns void

setResourceCollections

To set the resource collection

Parameter Type Description
resourceCol ResourcesModel[] Accepts the resource collections in ResourcesModel type
isEventDataRefresh (optional) boolean Accepts the boolean to refresh the appointment data source from remote or local

Returns void

setWorkHours

Sets different working hours on the required working days by accepting the required start and end time as well as the date collection as its parameters.

Parameter Type Description
dates Date[] Collection of dates on which the given start and end hour range needs to be applied.
start string Defines the work start hour.
end string Defines the work end hour.
groupIndex (optional) number Defines the resource index from last level.

Returns void

showSpinner

Allows to show the spinner on schedule at the required scenarios.

Returns void

Events

actionBegin

EmitType<ActionEventArgs>

Triggers on beginning of every scheduler action.

actionComplete

EmitType<ActionEventArgs>

Triggers on successful completion of the scheduler actions.

actionFailure

EmitType<ActionEventArgs>

Triggers when a scheduler action gets failed or interrupted and an error information will be returned.

beforePaste

EmitType<BeforePasteEventArgs>

Triggers once when pasting an event on the scheduler.

beforePrint

EmitType<BeforePrintEventArgs>

Triggers when the print event is called.

cellClick

EmitType<CellClickEventArgs>

Triggers when the scheduler cells are single clicked or on single tap on the same cells in mobile devices.

cellDoubleClick

EmitType<CellClickEventArgs>

Triggers when the scheduler cells are double clicked.

created

EmitType<Record>

Triggers after the scheduler component is created.

dataBinding

EmitType<ReturnType>

Triggers before the data binds to the scheduler.

dataBound

EmitType<ReturnType>

Triggers once the event data is bound to the scheduler.

destroyed

EmitType<Record>

Triggers when the scheduler component is destroyed.

drag

EmitType<DragEventArgs>

Triggers when an appointment is being in a dragged state.

dragStart

EmitType<DragEventArgs>

Triggers when an appointment is started to drag.

dragStop

EmitType<DragEventArgs>

Triggers when the dragging of appointment is stopped.

eventClick

EmitType<EventClickArgs>

Triggers when the events are single clicked or on single tapping the events on the mobile devices.

eventDoubleClick

EmitType<EventClickArgs>

Triggers when the events are double clicked or on double tapping the events on the desktop devices.

eventRendered

EmitType<EventRenderedArgs>

Triggers before each of the event getting rendered on the scheduler user interface.

excelExport

EmitType<ExcelExportEventArgs>

Triggers before the Excel export process begins.

hover

EmitType<HoverEventArgs>

Triggers when the scheduler elements are hovered.

moreEventsClick

EmitType<MoreEventsClickArgs>

Triggers when the more events indicator are clicked.

Triggers before the date or view navigation takes place on scheduler.

popupClose

EmitType<PopupCloseEventArgs>

Triggers before any of the scheduler popups close on the page.

popupOpen

EmitType<PopupOpenEventArgs>

Triggers before any of the scheduler popups opens on the page.

renderCell

EmitType<RenderCellEventArgs>

Triggers before each element of the schedule rendering on the page.

resizeStart

EmitType<ResizeEventArgs>

Triggers when an appointment is started to resize.

resizeStop

EmitType<ResizeEventArgs>

Triggers when the resizing of appointment is stopped.

resizing

EmitType<ResizeEventArgs>

Triggers when an appointment is being in a resizing action.

select

EmitType<SelectEventArgs>

Triggers when multiple cells or events are selected on the Scheduler.

tooltipOpen

EmitType<TooltipOpenEventArgs>

Triggers before the tooltip is rendered.

virtualScrollStart

EmitType<ScrollEventArgs>

Triggers when the scroll action is started. This event triggers only when allowVirtualScrolling or enableLazyLoading properties are enabled along with resource grouping.

virtualScrollStop

EmitType<ScrollEventArgs>

Triggers when the scroll action is stopped. This event triggers only when allowVirtualScrolling or enableLazyLoading properties are enabled along with resource grouping.

Contents
Contents

Search results

ScheduleComponent

ej-schedule represents the Angular Schedule Component.

<ejs-schedule></ejs-schedule>

Properties

agendaDaysCount

number

Sets the number of days to be displayed by default in Agenda View and in case of virtual scrolling, the number of days will be fetched on each scroll-end based on this count.

<ejs-schedule agendaDaysCount=2></ejs-schedule>

Defaults to 7

allowClipboard

boolean

Enables clipboard functionality for appointments, allowing them to be copied using keyboard shortcuts and pasted onto the Scheduler. When set to true, users can use keyboard shortcuts to cut, copy appointments and paste them into different time slots or calendars.

Defaults to false

allowDragAndDrop

boolean

When set to true, allows the appointments to move over the time slots. When an appointment is dragged, both its start and end time tends to change simultaneously allowing it to reschedule the appointment on some other time.

Defaults to true

allowInline

boolean

This property helps user to add/edit the event in inline. By default, it is set to false.

Defaults to false

allowKeyboardInteraction

boolean

When set to true, allows the keyboard interaction to take place on Schedule.

Defaults to true

allowMultiCellSelection

boolean

This property helps user to allow/prevent the selection of multiple cells. By default, it is set to true.

Defaults to true

allowMultiDrag

boolean

This property helps to drag the multiple selected events. By default, it is set to false.

Defaults to false

allowMultiRowSelection

boolean

This property helps user to allow/prevent the selection of multiple days(rows). By default, it is set to true.

Defaults to true

allowOverlap

boolean

Specifies whether overlapping appointments are allowed within the same time slot in the Scheduler.

Defaults to true

allowResizing

boolean

When set to true, allows the resizing of appointments. It allows the rescheduling of appointments either by changing the start or end time by dragging the event resize handlers.

Defaults to true

allowSwiping

boolean

Defines whether to enable date navigations via swipe in touch devices or not.

Defaults to true

calendarMode

CalendarType

It allows the Scheduler to display in other calendar modes. By default, Scheduler is displayed in Gregorian calendar mode.

<ejs-schedule calendarMode='Islamic'></ejs-schedule>

To change the mode, you can set either Gregorian or Islamic as a value to this calendarMode property.

Defaults to ‘Gregorian’

cellHeaderTemplate

string | object

It accepts either the string or HTMLElement as template design content and parse it appropriately before displaying it onto the month date cells. This template is only applicable for month view day cells.

<ejs-schedule currentView='Month'>
<ng-template #cellHeaderTemplate let-data>
  <div class="date-text">{{getDateHeaderText(data.date)}}</div>
</ng-template>
</ejs-schedule>
import { Component, ViewEncapsulation } from "@angular/core";
import { Internationalization } from '@syncfusion/ej2-base';

@Component({
  selector: "app-root",
  templateUrl: "app.component.html",
  styleUrls: ["app.component.css"],
  encapsulation: ViewEncapsulation.None
})
export class AppComponent {
  public instance: Internationalization = new Internationalization();
  getDateHeaderText: Function = (value: Date) => {
    return this.instance.formatDate(value, { skeleton: "Ed" });
  };
}

Defaults to null

cellTemplate

string | object

The template option which is used to render the customized work cells on the Schedule. Here, the template accepts either the string or HTMLElement as template design and then the parsed design is displayed onto the work cells. The fields accessible via template are as follows.

  • date: Returns the date of the cell.
  • groupIndex: Returns the group index of the cell.
  • type: Returns the type of the work cell. Refer to the below code snippet.
<ejs-schedule>
<ng-template #cellTemplate let-data>
    <div class="templatewrap" *ngIf="data.type == 'workCells'" [innerHTML]="getWorkCellText(data.date)"></div>
    <div class="templatewrap" *ngIf="data.type == 'monthCells'" [innerHTML]="getMonthCellText(data.date)"></div>
  </ng-template>
</ejs-schedule>
import { Component, ViewEncapsulation } from '@angular/core';
import { Internationalization } from '@syncfusion/ej2-base';

@Component({
  selector: 'app-root',
  templateUrl: 'app.component.html',
  styleUrls: ['app.component.css'],
  encapsulation: ViewEncapsulation.None
})
export class AppComponent {
  public instance: Internationalization = new Internationalization();
  getMonthCellText(date: Date): string {
    if (date.getMonth() === 10 && date.getDate() === 23) {
      return '<img src= "https://ej2.syncfusion.com/demos/src/schedule/images/birthday.svg" style="height:90%; width:90%"/>';
    } else if (date.getMonth() === 11 && date.getDate() === 9) {
      return '<img src= "https://ej2.syncfusion.com/demos/src/schedule/images/get-together.svg" style="height:90%; width:90%"/>';
    } else if (date.getMonth() === 11 && date.getDate() === 13) {
      return '<img src= "https://ej2.syncfusion.com/demos/src/schedule/images/birthday.svg" style="height:90%; width:90%"/>';
    }
    return '';
  }
  getWorkCellText(date: Date): string {
    let weekEnds: number[] = [0, 6];
    if (weekEnds.indexOf(date.getDay()) >= 0) {
      return "<img src='https://ej2.syncfusion.com/demos/src/schedule/images/newyear.svg' style='height:90%; width:90%'/>";
    }
    return '';
  }
}

Defaults to null

cssClass

string

It is used to customize the Schedule which accepts custom CSS class names that defines specific user-defined styles and themes to be applied on the Schedule element.

<ejs-schedule #scheduleObj cssClass='cell-dimension'></ejs-schedule>
import { Component, ViewEncapsulation } from "@angular/core";
/**
 * Default Button Controller
 */
@Component({
  selector: "app-root",
  templateUrl: "app.component.html",
  styles: [`.cell-dimension.e-schedule .e-vertical-view .e-date-header-wrap table col,
            .cell-dimension.e-schedule .e-vertical-view .e-content-wrap table col {
                width: 200px;}`
          ],
  encapsulation: ViewEncapsulation.None
})
export class AppComponent {
  constructor() {}
}

Defaults to null

currentView

View

To set the active view on scheduler, the currentView property can be used and it usually accepts either of the following available view options. The view option specified in this property will be initially loaded on the schedule.

  • Day: Denotes Day view of the scheduler.
  • Week: Denotes Week view of the scheduler.
  • WorkWeek: Denotes Work Week view of the scheduler.
  • Month: Denotes Month view of the scheduler.
  • Year: Denotes Year view of the scheduler.
  • Agenda: Denotes Agenda view of the scheduler.
  • MonthAgenda: Denotes Month Agenda view of the scheduler.
  • TimelineDay: Denotes Timeline Day view of the scheduler.
  • TimelineWeek: Denotes Timeline Week view of the scheduler.
  • TimelineWorkWeek: Denotes Timeline Work Week view of the scheduler.
  • TimelineMonth: Denotes Timeline Month view of the scheduler.
  • TimelineYear: Denotes Timeline Year view of the scheduler.
<ejs-schedule #scheduleObj currentView='Month'></ejs-schedule>

Defaults to ‘Week’

dateFormat

string

By default, Schedule follows the date-format as per the default culture assigned to it. It is also possible to manually set specific date format by using the dateFormat property.

<ejs-schedule dateFormat='dd-MMM-yyyy'></ejs-schedule>

The format of the date range label in the header bar depends on the dateFormat value or else based on the locale assigned to the Schedule.

Defaults to null

dateHeaderTemplate

string | object

It accepts either the string or HTMLElement as template design content and parse it appropriately before displaying it onto the date header cells. The field that can be accessed via this template is date.

<ejs-schedule>
	<ng-template #dateHeaderTemplate let-data>
		<div class="date-text">{{getDateHeaderText(data.date)}}</div>
	</ng-template>
</ejs-schedule>
import { Component, ViewEncapsulation } from "@angular/core";
import { Internationalization } from '@syncfusion/ej2-base';

@Component({
  selector: "app-root",
  templateUrl: "app.component.html",
  styleUrls: ["app.component.css"],
  encapsulation: ViewEncapsulation.None
})
export class AppComponent {
  public instance: Internationalization = new Internationalization();
  getDateHeaderText: Function = (value: Date) => {
    return this.instance.formatDate(value, { skeleton: "Ed" });
  };
}

Defaults to null

dateRangeTemplate

string | object

It accepts either the string or HTMLElement as template design content and parse it appropriately before displaying it onto the header date range.

Defaults to null

dayHeaderTemplate

string | object

It accepts either the string or HTMLElement as template design content and parse it appropriately before displaying it onto the day header cells. This template is only applicable for year view header cells.

Defaults to null

editorFooterTemplate

string | object

The template option to render the customized footer of the editor window.

Defaults to null

editorHeaderTemplate

string | object

The template option to render the customized header of the editor window.

Defaults to null

editorTemplate

string | object

The template option to render the customized editor window. The form elements defined within this template should be accompanied with e-field class, so as to fetch and process it from internally.

<ejs-schedule (popupOpen)='onPopupOpen($event)'>
	<ng-template #editorTemplate>
		<table class="custom-event-editor" width="100%" cellpadding="5">
			<tbody>
				<tr>
					<td class="e-textlabel">Summary</td>
					<td colspan="4">
						<input id="Subject" class="e-field e-input" type="text" value="" name="Subject" style="width: 100%" />
                    </td>
				</tr>
				<tr>
					<td class="e-textlabel">Status</td>
					<td colspan="4">
						<input type="text" id="EventType" name="EventType" class="e-field" style="width: 100%" />
                    </td>
				</tr>
				<tr>
					<td class="e-textlabel">From</td>
					<td colspan="4">
						<input id="StartTime" class="e-field" type="text" name="StartTime" />
                    </td>
				</tr>
				<tr>
					<td class="e-textlabel">To</td>
					<td colspan="4">
						<input id="EndTime" class="e-field" type="text" name="EndTime" />
                    </td>
				</tr>
				<tr>
					<td class="e-textlabel">Reason</td>
					<td colspan="4">
						<textarea id="Description" class="e-field e-input" name="Description" rows="3" cols="50" style="width: 100%; height: 60px !important; resize: vertical"></textarea>
					</td>
				</tr>
			</tbody>
		</table>
	</ng-template>
</ejs-schedule>
import { Component, ViewEncapsulation } from "@angular/core";
import { PopupOpenEventArgs } from '@syncfusion/ej2-angular-schedule';
import { DropDownList } from '@syncfusion/ej2-dropdowns';
import { DateTimePicker } from '@syncfusion/ej2-calendars';

@Component({
  selector: "app-root",
  templateUrl: "app.component.html",
  styleUrls: ["app.component.css"],
  encapsulation: ViewEncapsulation.None
})

export class AppComponent {
  onPopupOpen(args: PopupOpenEventArgs): void {
    if (args.type === "Editor") {
      let statusElement: HTMLInputElement = args.element.querySelector(
        "#EventType"
      ) as HTMLInputElement;
      if (!statusElement.classList.contains("e-dropdownlist")) {
        let dropDownListObject: DropDownList = new DropDownList({
          placeholder: "Choose status",
          value: statusElement.value,
          dataSource: ["New", "Requested", "Confirmed"]
        });
        dropDownListObject.appendTo(statusElement);
        statusElement.setAttribute("name", "EventType");
      }
      let startElement: HTMLInputElement = args.element.querySelector(
        "#StartTime"
      ) as HTMLInputElement;
      if (!startElement.classList.contains("e-datetimepicker")) {
        new DateTimePicker(
          { value: new Date(startElement.value) || new Date() },
          startElement
        );
      }
      let endElement: HTMLInputElement = args.element.querySelector(
        "#EndTime"
      ) as HTMLInputElement;
      if (!endElement.classList.contains("e-datetimepicker")) {
        new DateTimePicker(
          { value: new Date(endElement.value) || new Date() },
          endElement
        );
      }
    }
  }
}

Defaults to null

enableAdaptiveUI

boolean

When set to true, the header view navigations are listed under the popup and if we enable resource grouping, the compact view will be enabled.

Defaults to false

enableAllDayScroll

boolean

When set to true, If valid, the scroll on the all day row is activated when the all day row height reaches the max height when the all day row is expanded.

Defaults to false

enableHtmlSanitizer

boolean

Specifies whether to enable the rendering of untrusted HTML values in the Schedule component. When this property is enabled, the component will sanitize any suspected untrusted strings and scripts before rendering them.

Defaults to true

enablePersistence

boolean

Enable or disable persisting component’s state between page reloads.

Defaults to false

enableRecurrenceValidation

boolean

The recurrence validation will be done by default. When this property is set to false, the recurrence validation will be skipped.

Defaults to true

enableRtl

boolean

Enable or disable rendering component in right to left direction.

Defaults to false

endHour

string

It is used to specify the end hour, at which the Schedule ends. It too accepts the time string in a short skeleton format.

<ejs-schedule endHour='18:00'></ejs-schedule>

Defaults to ‘24:00’

eventDragArea

string

It enables the external drag and drop support for appointments on scheduler, to be able to move them out of the scheduler layout. When the drag area is explicitly set with specific DOM element name, the appointments can be dragged anywhere within the specified drag area location.

<ejs-schedule eventDragArea='body'></ejs-schedule>

Defaults to null

eventSettings

EventSettingsModel

Complete set of settings related to Schedule events to bind it to local or remote dataSource, map applicable database fields and other validation to be carried out on the available fields.

<ejs-schedule [eventSettings]="eventSettings"></ejs-schedule>
import { Component, ViewEncapsulation } from "@angular/core";
import { EventSettingsModel } from '@syncfusion/ej2-angular-schedule';

@Component({
  selector: "app-root",
  templateUrl: "app.component.html",
  styleUrls: ["app.component.css"],
  encapsulation: ViewEncapsulation.None
})

export class AppComponent {
  public eventSettings: EventSettingsModel = {
    dataSource: [
      {
        Id: 1,
        Subject: "Event-1",
        StartTime: new Date(2017, 9, 16, 23),
        EndTime: new Date(2017, 9, 17, 10),
        IsAllDay: false
      }
    ]
  };
}

Defaults to null

firstDayOfWeek

number

This option allows the user to set the first day of a week on Schedule. It should be based on the locale set to it and each culture defines its own first day of week values. If needed, the user can set it manually on his own by defining the value through this property. It usually accepts the integer values, whereby 0 is always denoted as Sunday, 1 as Monday and so on.

<ejs-schedule [firstDayOfWeek]=2></ejs-schedule>

Defaults to 0

firstMonthOfYear

number

This property helps render the year view customized months. By default, it is set to 0.

<ejs-schedule [firstMonthOfYear]=2>
    <e-views>
        <e-view option="Year"></e-view>
        <e-view option="TimelineYear"></e-view>
    </e-views>
</ejs-schedule>

Defaults to 0

group

GroupModel

Allows defining the group related settings of multiple resources. When this property is non-empty, it means that the resources will be grouped on the schedule layout based on the provided resource names.

<ejs-schedule [group]="group">
	<e-resources>
		<e-resource field='AirlineId' title='Airline Name' name='Airlines' [allowMultiple]='allowMultiple'
			[dataSource]='resourceDataSource' textField='AirlineName' idField='AirlineId' colorField='AirlineColor'>
		</e-resource>
	</e-resources>
</ejs-schedule>
import { Component, ViewEncapsulation } from "@angular/core";
import { GroupModel } from "@syncfusion/ej2-angular-schedule";

@Component({
  selector: "app-root",
  templateUrl: "app.component.html",
  styleUrls: ["app.component.css"],
  encapsulation: ViewEncapsulation.None
})

export class AppComponent {
  public resourceDataSource: Object[] = [
    { AirlineName: "Airways 1", AirlineId: 1, AirlineColor: "#EA7A57" },
    { AirlineName: "Airways 2", AirlineId: 2, AirlineColor: "#357cd2" },
    { AirlineName: "Airways 3", AirlineId: 3, AirlineColor: "#7fa900" }
  ];
  public group: GroupModel = { resources: ["Airlines"] };
}

Defaults to {}

headerIndentTemplate

string | object

Template option to customize the header indent bar. Here, the template accepts either the string or HTMLElement as template design and then the parsed design is displayed onto the header indent cell. Refer to the below code snippet.

<ejs-schedule>
  <e-views>
    <e-view option="Day"></e-view>
    <e-view option="Week"></e-view>
    <e-view option="WorkWeek"></e-view>
  </e-views>
  <ng-template #headerIndentTemplate let-data >
    <div class="template-wrap" *ngIf="data.className[0] == 'e-header-cells'">
      Template
    </div>
  </ng-template>
</ejs-schedule>
import { Component, ViewEncapsulation } from "@angular/core";
import { DayService, WeekService, WorkWeekService, ResizeService, DragAndDropService
} from '@syncfusion/ej2-angular-schedule';

@Component({
  selector: "app-root",
  templateUrl: "app.component.html",
  styleUrls: ["app.component.css"],
  providers: [DayService, WeekService, WorkWeekService, ResizeService, DragAndDropService],
  encapsulation: ViewEncapsulation.None
})

export class AppComponent {
}

Defaults to null

headerRows

HeaderRowsModel[]

Allows defining the collection of custom header rows to display the year, month, week, date and hour label as an individual row on the timeline view of the scheduler.

<ejs-schedule>
	<e-header-rows>
		<e-header-row option='Year'></e-header-row>
		<e-header-row option='Month'></e-header-row>
		<e-header-row option='Week'></e-header-row>
		<e-header-row option='Date'></e-header-row>
		<e-header-row option='Hour'></e-header-row>
	</e-header-rows>
	<e-views>
		<e-view option='TimelineWeek'></e-view>
	</e-views>
</ejs-schedule>

Defaults to []

height

string | number

Sets the height of the Schedule component, accepting both string and number values.

<ejs-schedule height='550px'></ejs-schedule>

The string type includes either pixel or percentage values. When height is set with specific pixel value, then the Schedule will be rendered to that specified space. In case, if auto value is set, then the height of the Schedule gets auto-adjusted within the given container.

Defaults to ‘auto’

hideEmptyAgendaDays

boolean

The days which does not has even a single event to display will be hidden from the UI of Agenda View by default. When this property is set to false, the empty dates will also be displayed on the Schedule.

Defaults to true

locale

string

Overrides the global culture and localization value for this component. Default global culture is ‘en-US’.

Defaults to

maxDate

Date

To define the maximum date on the Schedule, maxDate property can be defined. Usually, it defaults to the new Date(2099, 11, 31).

<ejs-schedule height='650px' [maxDate]='maxDate'> </ejs-schedule>
import { Component } from '@angular/core';
import { DayService, WeekService, WorkWeekService, MonthService, AgendaService, ResizeService, DragAndDropService } from '@syncfusion/ej2-angular-schedule';

@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    providers: [DayService, WeekService, WorkWeekService, MonthService, AgendaService, ResizeService, DragAndDropService]
})
export class AppComponent {
    public maxDate: Date = new Date(2021, 1, 1);
}

Defaults to new Date(2099, 11, 31)

minDate

Date

To define the minimum date on the Schedule, minDate property can be defined. Usually, it defaults to the new Date(1900, 0, 1).

 <ejs-schedule height='650px' [minDate]='minDate'></ejs-schedule>
import { Component } from '@angular/core';
import { DayService, WeekService, WorkWeekService, MonthService, AgendaService, ResizeService, DragAndDropService } from '@syncfusion/ej2-angular-schedule';

@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    providers: [DayService, WeekService, WorkWeekService, MonthService, AgendaService, ResizeService, DragAndDropService]
})
export class AppComponent {
    public minDate: Date = new Date(2020, 6, 1);
}

Defaults to new Date(1900, 0, 1)

monthHeaderTemplate

string | object

It accepts either the string or HTMLElement as template design content and parse it appropriately before displaying it onto the month header cells. This template is only applicable for year view header cells.

Defaults to null

monthsCount

number

This option allows the user to set the number of months count to be displayed on the Schedule.

<ejs-schedule [monthsCount]="16">
  <e-views>
    <e-view option="TimelineYear"></e-view>
    <e-view option="Year"></e-view>
  </e-views>
</ejs-schedule>
import { Component } from '@angular/core';
import { YearService, TimelineYearService, DragAndDropService } from '@syncfusion/ej2-angular-schedule';

@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    providers: [YearService,TimelineYearService, DragAndDropService]
})
export class AppComponent {
}

Defaults to 12

overscanCount

number

Specifies the number of additional rows or columns to render outside the visible area during virtual scrolling. This property helps in achieving smoother scrolling by pre-loading data just outside the visible region.

Defaults to 3

quickInfoOnSelectionEnd

boolean

This property helps to show quick popup after multiple cell selection. By default, it is set to false.

Defaults to false

quickInfoTemplates

QuickInfoTemplatesModel

The template option to customize the quick window. The three sections of the quick popup whereas the header, content, and footer can be easily customized with individual template option.

<ejs-schedule #scheduleObj (popupOpen)="onPopupOpen($event)">
	<ng-template #quickInfoTemplatesHeader let-data>
		<div *ngIf="data.elementType == 'cell' || data.elementType == 'event'">
			<div class="e-popup-header">
				<div class="e-header-icon-wrapper">
					<div *ngIf="data.elementType == 'event'" class="subject">{{data.Subject}}</div>
					<button class="e-close e-close-icon e-icons" title="Close" (click)="onCloseClick($event)"></button>
				</div>
			</div>
		</div>
	</ng-template>
	<ng-template #quickInfoTemplatesContent let-data>
		<div *ngIf="data.elementType == 'cell'" class="e-cell-content">
			<form class="e-schedule-form">
				<div style="padding:10px">
					<input class="subject e-field e-input" type="text" name="Subject" placeholder="Title" style="width:100%">
          </div>
					<div style="padding:10px">
						<input class="location e-field e-input" type="text" name="Location" placeholder="Location" style="width:100%">
          </div>
			</form>
		</div>
		<div *ngIf="data.elementType == 'event'" class="e-event-content">
			<div class="start-time">Start: {{data.StartTime.toLocaleString()}}</div>
			<div class="end-time">End: {{data.EndTime.toLocaleString()}}</div>
			<div *ngIf="data.Location != undefined && data.Location != ''" class="location">Location: {{data.Location}}
			</div>
		</div>
	</ng-template>
	<ng-template #quickInfoTemplatesFooter let-data>
		<div *ngIf="data.elementType == 'cell'" class="e-cell-footer">
			<div class="left-button">
				<button class="e-event-details" title="Extra Details" (click)="onDetailsClick($event)">More Details</button>
			</div>
			<div class="right-button">
				<button class="e-event-create" title="Add" (click)="onAddClick($event)">Add</button>
			</div>
		</div>
		<div *ngIf="data.elementType == 'event'" class="e-event-footer">
			<div class="left-button">
				<button class="e-delete" title="Delete" (click)="onDeleteClick($event)">Delete</button>
				<button *ngIf="data.RecurrenceRule != undefined && data.RecurrenceRule != ''" class="e-delete-series"
            title="Delete" (click)="onDeleteClick($event)">Delete Series</button>
			</div>
			<div class="right-button">
				<button class="e-edit" title="Edit" (click)="onEditClick($event)">Edit</button>
				<button *ngIf="data.RecurrenceRule != undefined && data.RecurrenceRule != ''" class="e-edit-series"
            title="Edit" (click)="onEditClick($event)">Edit Series</button>
			</div>
		</div>
	</ng-template>
</ejs-schedule>
import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { isNullOrUndefined } from "@syncfusion/ej2-base";
import { PopupOpenEventArgs, ScheduleComponent, CurrentAction } from "@syncfusion/ej2-angular-schedule";

@Component({
  selector: "app-root",
  templateUrl: "app.component.html",
  styleUrls: ["app.component.css"],
  encapsulation: ViewEncapsulation.None
})

export class AppComponent {
  @ViewChild("scheduleObj")
  public scheduleObj: ScheduleComponent;
  private selectionTarget: Element;
  public onPopupOpen(args: PopupOpenEventArgs): void {
    this.selectionTarget = null;
    this.selectionTarget = args.target;
  }
  public onDetailsClick(): void {
    this.onCloseClick();
    const data: Object = this.scheduleObj.getCellDetails(
      this.scheduleObj.getSelectedElements()
    ) as Object;
    this.scheduleObj.openEditor(data, "Add");
  }
  public onAddClick(): void {
    this.onCloseClick();
    const data: Object = this.scheduleObj.getCellDetails(
      this.scheduleObj.getSelectedElements()
    ) as Object;
    const eventData: {
      [key: string]: Object;
    } = this.scheduleObj.eventWindow.getObjectFromFormData(
      "e-quick-popup-wrapper"
    );
    this.scheduleObj.eventWindow.convertToEventData(
      data as { [key: string]: Object },
      eventData
    );
    eventData.Id = (this.scheduleObj.eventBase.getEventMaxID() as number) + 1;
    this.scheduleObj.addEvent(eventData);
  }
  public onEditClick(args: any): void {
    if (this.selectionTarget) {
      let eventData: {
        [key: string]: Object;
      } = this.scheduleObj.getEventDetails(this.selectionTarget) as {
        [key: string]: Object;
      };
      let currentAction: CurrentAction = "Save";
      if (
        !isNullOrUndefined(eventData.RecurrenceRule) &&
        eventData.RecurrenceRule !== ""
      ) {
        if (args.target.classList.contains("e-edit-series")) {
          currentAction = "EditSeries";
          eventData = (this.scheduleObj.eventBase as any).getRecurrenceEvent(eventData);
        } else {
          currentAction = "EditOccurrence";
        }
      }
      this.scheduleObj.openEditor(eventData, currentAction);
    }
  }
  public onDeleteClick(args: any): void {
    this.onCloseClick();
    if (this.selectionTarget) {
      const eventData: {
        [key: string]: Object;
      } = this.scheduleObj.getEventDetails(this.selectionTarget) as {
        [key: string]: Object;
      };
      let currentAction: CurrentAction;
      if (
        !isNullOrUndefined(eventData.RecurrenceRule) &&
        eventData.RecurrenceRule !== ""
      ) {
        currentAction = args.target.classList.contains("e-delete-series")
          ? "DeleteSeries"
          : "DeleteOccurrence";
      }
      this.scheduleObj.deleteEvent(eventData, currentAction);
    }
  }
  public onCloseClick(): void {
    this.scheduleObj.quickPopup.quickPopupHide();
  }
}

Defaults to null

readonly

boolean

When set to true, makes the Schedule to render in a read only mode. No CRUD actions will be allowed at this time.

Defaults to false

resourceHeaderTemplate

string | object

Template option to customize the resource header bar. Here, the template accepts either the string or HTMLElement as template design and then the parsed design is displayed onto the resource header cells. The following can be accessible via template.

  • resource - All the resource fields.
  • resourceData - Object collection of current resource. Refer to the below code snippet.
<ejs-schedule [group]='group'>
	<e-resources>
		<e-resource field="DoctorId" title="Doctor Name" name="Doctors" [dataSource]="doctorDataSource" textField='text' idField='id' colorField='color' designationField='designation'>
		</e-resource>
	</e-resources>
	<ng-template #resourceHeaderTemplate let-data>
		<div class='template-wrap'>
			<div class="resource-details">
				<div class="resource-name">{{data.resourceData.text}}</div>
				<div class="resource-designation">{{data.resourceData.designation}}</div>
			</div>
		</div>
	</ng-template>
</ejs-schedule>
import { Component, ViewEncapsulation } from "@angular/core";
import { GroupModel } from "@syncfusion/ej2-angular-schedule";

@Component({
  selector: "app-root",
  templateUrl: "app.component.html",
  styleUrls: ["app.component.css"],
  encapsulation: ViewEncapsulation.None
})

export class AppComponent {
  public group: GroupModel = {
    resources: ["Doctors"]
  };
  public allowMultipleDoctors: Boolean = true;
  public doctorDataSource: Object[] = [
    { text: "Will Smith", id: 1, color: "#ea7a57", designation: "Cardioligst" },
    { text: "Alice", id: 2, color: "#7fa900", designation: "Neurologist" }
  ];
}

Defaults to null

resources

ResourcesModel[]

Allows defining the collection of resources to be displayed on the Schedule. The resource collection needs to be defined with unique resource names to identify it along with the respective dataSource and field mapping options.

<ejs-schedule [group]="group">
	<e-resources>
		<e-resource field='AirlineId' title='Airline Name' name='Airlines' [allowMultiple]='allowMultiple'
			[dataSource]='resourceDataSource' textField='AirlineName' idField='AirlineId' colorField='AirlineColor'>
		</e-resource>
	</e-resources>
</ejs-schedule>
import { Component, ViewEncapsulation } from "@angular/core";
import { GroupModel } from "@syncfusion/ej2-angular-schedule";

@Component({
  selector: "app-root",
  templateUrl: "app.component.html",
  styleUrls: ["app.component.css"],
  encapsulation: ViewEncapsulation.None
})

export class AppComponent {
  public resourceDataSource: Object[] = [
    { AirlineName: "Airways 1", AirlineId: 1, AirlineColor: "#EA7A57" },
    { AirlineName: "Airways 2", AirlineId: 2, AirlineColor: "#357cd2" },
    { AirlineName: "Airways 3", AirlineId: 3, AirlineColor: "#7fa900" }
  ];
  public group: GroupModel = { resources: ["Airlines"] };
}

Defaults to []

rowAutoHeight

boolean

when set to true, allows the height of the work-cells to adjust automatically based on the number of appointments present in those time ranges.

Defaults to false

selectedDate

Date

To mark the active (current) date on the Schedule, selectedDate property can be defined. Usually, it defaults to the current System date.

<ejs-schedule [selectedDate]="selectedDate"></ejs-schedule>
import { Component, ViewEncapsulation } from "@angular/core";

@Component({
  selector: "app-root",
  templateUrl: "app.component.html",
  styleUrls: ["app.component.css"],
  encapsulation: ViewEncapsulation.None
})

export class AppComponent {
  public selectedDate: Date = new Date(2023, 5, 5);
}

Defaults to ‘new Date()’

showHeaderBar

boolean

When set to false, hides the header bar of the Schedule from UI. By default, the header bar holds the date and view navigation options, to which the user can add their own custom items onto it.

Defaults to true

showQuickInfo

boolean

When set to true, displays a quick popup with cell or event details on single clicking over the cells or on events. By default, it is set to true.

Defaults to true

showTimeIndicator

boolean

When set to false, hides the current time indicator from the Schedule. Otherwise, it visually depicts the live current system time appropriately on the user interface.

Defaults to true

showWeekNumber

boolean

When set to true, displays the week number of the current view date range. By default, it is set to false.

Defaults to false

showWeekend

boolean

When set to false, it hides the weekend days of a week from the Schedule. The days which are not defined in the working days collection are usually treated as weekend days. Note: By default, this option is not applicable on Work Week view. For example, if the working days are defined as [1, 2, 3, 4], then the remaining days of that week will be considered as the weekend days and will be hidden on all the views.

Defaults to true

startHour

string

It is used to specify the starting hour, from which the Schedule starts to display. It accepts the time string in a short skeleton format and also, hides the time beyond the specified start time.

<ejs-schedule startHour='10:00'></ejs-schedule>

Defaults to ‘00:00’

timeFormat

string

By default, Schedule follows the time-format as per the default culture assigned to it. It is also possible to manually set specific time format by using the timeFormat property.

Defaults to null

timeScale

TimeScaleModel

Allows to set different time duration on Schedule along with the customized grid count. It also has template option to customize the time slots with required time values in its own format.

<ejs-schedule [timeScale]="timeScale"></ejs-schedule>
import { Component, ViewEncapsulation } from "@angular/core";
import { TimeScaleModel } from '@syncfusion/ej2-angular-schedule';

@Component({
  selector: "app-root",
  templateUrl: "app.component.html",
  styleUrls: ["app.component.css"],
  encapsulation: ViewEncapsulation.None
})

export class AppComponent {  
    public timeScale: TimeScaleModel = { enable: true, interval: 60, slotCount: 6 };
}

Defaults to { enable: true, interval: 60, slotCount: 2, majorSlotTemplate: null, minorSlotTemplate: null }

timezone

string

Schedule will be assigned with specific timezone, so as to display the events in it accordingly. By default, Schedule dates are processed with System timezone, as no timezone will be assigned specifically to the Schedule at the initial time. Whenever the Schedule is bound to remote data services, it is always recommended to set specific timezone to Schedule to make the events on it to display on the same time irrespective of the system timezone. It usually accepts the valid IANA timezone names.

<ejs-schedule timezone="UTC"></ejs-schedule>

Defaults to null

timezoneDataSource

TimezoneFields[]

Allows to define the collection of timezone items in the Schedule. Only the items bound to this property get listed out in the timezone dropdown of the appointment window.

<ejs-schedule [timezoneDataSource]=timezoneDataSource></ejs-schedule>
import { Component, ViewEncapsulation } from "@angular/core";

@Component({
  selector: "app-root",
  templateUrl: "app.component.html",
  styleUrls: ["app.component.css"],
  encapsulation: ViewEncapsulation.None
})

export class AppComponent {
  public timezoneDataSource : [
                    { Value: 'Pacific/Niue', Text: 'Niue' },
                    { Value: 'Pacific/Pago_Pago', Text: 'Pago Pago' },
                    { Value: 'Pacific/Honolulu', Text: 'Hawaii Time' },
                    { Value: 'Pacific/Rarotonga', Text: 'Rarotonga' },
                    { Value: 'Pacific/Tahiti', Text: 'Tahiti' }
                ]
}

Defaults to timezoneData

toolbarItems

ToolbarItemModel[]

To render the custom toolbar items, the toolbarItems property can be used. It contains built-in and custom toolbar items. To avail the built-in toolbar items, the below string values are assigned to the name property of the ToolbarItemModel.

  • Previous: Schedule component navigates to the previous date from the current date.
  • Next: Schedule component navigates to the next date from the current date.
  • Today: Schedule component navigates to the current date from any date.
  • Views: Schedule component render the defined view options in the toolbar. If view option is not defined, then it will render default view options in the Schedule.
  • DateRangeText: Schedule component displays the current date text range.
  • NewEvent: Schedule component render the icon to add a new event.

Defaults to []

views

View[] | ViewsModel[]

This property holds the views collection and its configurations. It accepts either the array of view names or the array of view objects that holds different configurations for each views. By default, Schedule displays all the views namely Day, Week, Work Week, Month and Agenda. Example for array of views:

Example for array of view objects:

Defaults to ’[“Day”, “Week”, “WorkWeek”, “Month”, “Agenda”]’

weekRule

WeekRule

It allows the Scheduler to display week numbers based on following available week options. The week option specified in this property will be initially loaded on the schedule.

  • FirstDay: Denotes that the first week of the year starts on the first day of the year and ends before the following designated first day of the week.
  • FirstFourDayWeek:Denotes that the first week of the year is the first week with four or more days before the designated first day of the week.
  • FirstFullWeek: Denotes that the first week of the year begins on the first occurrence of the designated first day of the week on or after the first day of the year.
<ejs-schedule [showWeekNumber]=true weekRule='FirstFourDayWeek'></ejs-schedule>

Defaults to ‘FirstDay’

width

string | number

Sets the width of the Schedule component, accepting both string and number values.

<ejs-schedule width='100%'></ejs-schedule>

The string value can be either pixel or percentage format. When set to auto, the Schedule width gets auto-adjusted and display its content related to the viewable screen size.

Defaults to ‘auto’

workDays

number[]

It is used to set the working days on Schedule. The only days that are defined in this collection will be rendered on the workWeek view whereas on other views, it will display all the usual days and simply highlights the working days with different shade.

<ejs-schedule [workDays]='workWeekDays'></ejs-schedule>
import { Component, ViewEncapsulation } from "@angular/core";

@Component({
  selector: "app-root",
  templateUrl: "app.component.html",
  styleUrls: ["app.component.css"],
  encapsulation: ViewEncapsulation.None
})

export class AppComponent {  
    public workWeekDays: number[] = [1, 3, 5];
}

Defaults to ’[1, 2, 3, 4, 5]’

workHours

WorkHoursModel

The working hours should be highlighted on Schedule with different color shade and an additional option must be provided to highlight it or not. This functionality is handled through workHours property and the start work hour should be 9 AM by default and end work hour should point to 6 PM. The start and end working hours needs to be provided as Time value of short skeleton type.

<ejs-schedule [workHours]="scheduleHours"></ejs-schedule>
import { Component, ViewEncapsulation } from "@angular/core";
import { WorkHoursModel } from '@syncfusion/ej2-angular-schedule';

@Component({
  selector: "app-root",
  templateUrl: "app.component.html",
  styleUrls: ["app.component.css"],
  encapsulation: ViewEncapsulation.None
})

export class AppComponent {  
    public scheduleHours: WorkHoursModel  = { highlight: true, start: '11:00', end: '20:00' };
}

Defaults to { highlight: true, start: ‘09:00’, end: ‘18:00’ }

Methods

addEvent

Adds the newly created event into the Schedule dataSource.

Parameter Type Description
data Record | Record[] Single or collection of event objects to be added into Schedule.

Returns void

addResource

Adds the resources to the specified index.

Parameter Type Description
resources Record | Record[] Accepts the resource data in single or collection of data.
name string Name of the resource defined in resources collection.
index number Index or position where the resource should be added.

Returns void

changeCurrentView

Current View could be change based on the provided parameters.

Parameter Type Description
viewName View Accept the view in the viewCollections.
viewIndex (optional) number Accept the viewIndex in the viewCollections.

Returns void

closeEditor

To manually close the event editor window

Returns void

closeOverlapAlert

To manually close the overlap validation Alert.

Returns void

closeQuickInfoPopup

To manually close the quick info popup

Returns void

closeTooltip

Closes the tooltip. For example, when the context menu is opened for an event, the tooltip can be closed by calling this method.

Returns void

collapseResource

This method allows to collapse the resource that available on the scheduler.

Parameter Type Description
resourceId string | number Accepts the resource id in either string or number type
name string Accepts the name of the resource collection

Returns void

copy

Method to copy events from an HTMLElement or an array of HTMLElements.

Parameter Type Description
elements HTMLElement[] Accepts an array of HTMLElement

Returns void

cut

Method to cut events from an HTMLElement or an array of HTMLElements.

Parameter Type Description
elements HTMLElement[] Accepts an array of HTMLElement

Returns void

deleteEvent

Deletes the events based on the provided ID or event collection in the argument list.

Parameter Type Description
id string | number | Record | Record[] Accepts the ID as string or number type or single or collection of the event object which needs to be removed from the Schedule.
currentAction (optional) CurrentAction Denotes the delete action that takes place either on occurrence or series events.
The valid current action names are Delete, DeleteOccurrence or DeleteSeries.

Returns void

destroy

Destroys the Schedule component.

Returns void

expandResource

This method allows to expand the resource that available on the scheduler.

Parameter Type Description
resourceId string | number Accepts the resource id in either string or number type
name string Accepts the name of the resource collection

Returns void

exportToExcel

Allows the Scheduler events data to be exported as an Excel file either in .xlsx or .csv file formats. By default, the whole event collection bound to the Scheduler gets exported as an Excel file. To export only the specific events of Scheduler, you need to pass the custom data collection as a parameter to this exportToExcel method. This method accepts the export options as arguments such as fileName, exportType, fields, customData, and includeOccurrences. The fileName denotes the name to be given for the exported file and the exportType allows you to set the format of an Excel file to be exported either as .xlsx or .csv. The custom or specific field collection of event dataSource to be exported can be provided through fields option and the custom data collection can be exported by passing them through the customData option. There also exists option to export each individual instances of the recurring events to an Excel file, by setting true or false to the includeOccurrences option, denoting either to include or exclude the occurrences as separate instances on an exported Excel file.

Parameter Type Description
excelExportOptions (optional) ExportOptions The export options to be set before start with exporting the Scheduler events to an Excel file.

Returns void

exportToICalendar

Exports the Scheduler events to a calendar (.ics) file. By default, the calendar is exported with a file name Calendar.ics. To change this file name on export, pass the custom string value as fileName to get the file downloaded with this provided name.

Parameter Type Description
fileName (optional) string Accepts the string value.
customData (optional) Record[] Accepts the collection of objects.

Returns void

generateEventOccurrences

Generates the occurrences of a single recurrence event based on the provided event.

Parameter Type Description
event Record Accepts the parent recurrence event from which the occurrences are generated.
startDate (optional) Date Accepts the start date for the event occurrences. If not provided, the event’s start date will be used.

Returns Record[]

getBlockEvents

Retrieves the entire collection of block events bound to the Schedule.

Parameter Type Description
startDate (optional) Date Accepts the start date.
endDate (optional) Date Accepts te end date.
includeOccurrences (optional) boolean Accepts the boolean value to process the occurrence from recurrence series.

Returns Record[]

getCellDetails

Retrieves the start and end time information of the specific cell element.

Parameter Type Description
tdCol Element | Element[] Accepts the single or collection of elements.

Returns CellClickEventArgs

getCurrentViewDates

Retrieves the dates that lies on active view of Schedule.

Returns Date[]

getCurrentViewEvents

Retrieves the events that lies on the current date range of the active view of Schedule.

Returns Record[]

getCurrentViewIndex

Return the current view Index.

Returns number

getDateRangeText

Retrieves a formatted string representing the date range of the given date collection.

Parameter Type Description
dates Date[] An array of Date objects representing the date range.

Returns string

getDeletedOccurrences

Get deleted occurrences from given recurrence series.

Parameter Type Description
recurrenceData string | number | Record Accepts the parent ID of the event object or parent event object

Returns Record[]

getEventDetails

To retrieve the appointment object from element.

Parameter Type Description
element Element Denotes the event UI element on the Schedule.

Returns Record

getEventMaxID

Get the maximum id of an event.

Returns number | string

getEvents

Retrieves the entire collection of events bound to the Schedule.

Parameter Type Description
startDate (optional) Date Accepts the start date.
endDate (optional) Date Accepts te end date.
includeOccurrences (optional) boolean Accepts the boolean value to process the occurrence from recurrence series.

Returns Record[]

getIndexFromResourceId

Select the resources to the based on id.

Parameter Type Description
id string | number id of the resource defined in resources collection.
name (optional) string Name of the resource defined in resources collection.

Returns number

getOccurrencesByID

Retrieves the occurrences of a single recurrence event based on the provided parent ID.

Parameter Type Description
eventID number | string ID of the parent recurrence data from which the occurrences are fetched.

Returns Record[]

getOccurrencesByRange

Retrieves all the occurrences that lies between the specific start and end time range.

Parameter Type Description
startTime Date Denotes the start time range.
endTime Date Denotes the end time range.

Returns Record[]

getResourceCollections

To get the resource collection

Returns ResourcesModel[]

getResourcesByIndex

Retrieves the resource details based on the provided resource index.

Parameter Type Description
index number index of the resources at the last level.

Returns ResourceDetails

getSelectedElements

Retrieves the selected cell elements.

Returns Element[]

getViewDates

Retrieves an array of dates based on the specified date collection direction.

Parameter Type Description
type (optional) NavigationDirection The direction for date collection. Options are:
- ‘Previous’: Returns the previous date range collection from the current rendered date.
- ‘Next’: Returns the next date range collection from the current rendered date.
- ‘Current’: Returns the current rendered date collection.

Returns Date[]

hideSpinner

When the spinner is shown manually using showSpinner method, it can be hidden using this hideSpinner method.

Returns void

importICalendar

Imports the events from an .ics file downloaded from any of the calendars like Google or Outlook into the Scheduler. This method accepts the blob object or string format of an .ics file to be imported as a mandatory argument.

Parameter Type Description
fileContent Blob | string Accepts the file object or string format of an .ics file.

Returns void

isSlotAvailable

To check whether the given time range slots are available for event creation or already occupied by other events. This method currently focuses on validating appointments within the current view date range. However, it does not extend this availability check to recurrence occurrences outside of the current date range.

Parameter Type Description
startTime Date | Record Denotes the start time of the slot.
endTime (optional) Date Denotes the end time of the slot.
groupIndex (optional) number Defines the resource index from last level.

Returns boolean

openEditor

To manually open the event editor on specific time or on certain events.

Parameter Type Description
data Record It can be either cell data or event data.
action CurrentAction Defines the action for which the editor needs to be opened such as either for new event creation or
for editing of existing events. The applicable action names that can be used here are Add, Save, EditOccurrence
and EditSeries.
isEventData (optional) boolean It allows to decide whether the editor needs to be opened with the clicked cell details or with the
passed event details.
repeatType (optional) number It opens the editor with the recurrence options based on the provided repeat type.

Returns void

openOverlapAlert

To manually open the overlap validation Alert.

Parameter Type Description
args PopupOpenEventArgs The arguments for opening the popup.

Returns void

openQuickInfoPopup

To manually open the quick info popup based on cell or event details.

Parameter Type Description
data Record Defines the cell or event data. If the data contains valid ID, it will open event quick info popup,
otherwise cell quick info popup displayed.

Returns void

paste

Method to create a paste event with clipboard data

Parameter Type Description
targetElement HTMLElement Accepts HTMLElement

Returns void

print

Method allows to print the scheduler.

Parameter Type Description
printOptions (optional) ScheduleModel The export options to be set before start with exporting
the Scheduler events to the print window.

Returns void

refreshEvents

Refreshes the event dataSource. This method may be useful when the events alone in the schedule needs to be re-rendered.

Parameter Type Description
isRemoteRefresh (optional) boolean Accepts the boolean to refresh data from remote or local

Returns void

refreshLayout

Refreshes the Schedule layout without re-render.

Returns void

refreshTemplates

Method to refresh the given Schedule templates

Parameter Type Description
templateName (optional) string Accepts the template name

Returns void

removeResource

Removes the specified resource.

Parameter Type Description
resourceId string | string[] | number | number[] Specifies the resource id to be removed.
name string Specifies the resource name from which the id should be referred.

Returns void

resetWorkHours

Removes or resets different working hours on the required working days by accepting the required start and end time as well as the date collection as its parameters. if no parameters has been passed to this function, it will remove all the work hours.

Parameter Type Description
dates (optional) Date[] Collection of dates on which the given start and end hour range need to be applied.
start (optional) string Defines the work start hour.
end (optional) string Defines the work end hour.
groupIndex (optional) number Defines the resource index from last level.

Returns void

saveEvent

Updates the changes made in the event object by passing it as an parameter into the dataSource.

Parameter Type Description
data Record | Record[] Single or collection of event objects to be saved into Schedule.
currentAction (optional) CurrentAction Denotes the action that takes place either for editing occurrence or series.
The valid current action names are EditOccurrence or EditSeries.

Returns void

scrollTo

Scrolls the Schedule content area to the specified time.

Parameter Type Description
hour string Accepts the time value in the skeleton format of ‘Hm’.
scrollDate (optional) Date Accepts the date object value.

Returns void

scrollToResource

This method allows scroll to the position of the any resources that available on the scheduler. This method is applicable for without Agenda and Month agenda views of the schedule.

Parameter Type Description
resourceId string | number Accepts the resource id in either string or number type
groupName (optional) string Accepts the name of the resource collection

Returns void

selectResourceByIndex

Select the resource based on group index in mobile mode.

Parameter Type Description
groupIndex number Defines the resource index based on last level.

Returns void

setRecurrenceEditor

Set the recurrence editor instance from custom editor template.

Parameter Type Description
recurrenceEditor RecurrenceEditor instance has passed to fetch the instance in event window.

Returns void

setResourceCollections

To set the resource collection

Parameter Type Description
resourceCol ResourcesModel[] Accepts the resource collections in ResourcesModel type
isEventDataRefresh (optional) boolean Accepts the boolean to refresh the appointment data source from remote or local

Returns void

setWorkHours

Sets different working hours on the required working days by accepting the required start and end time as well as the date collection as its parameters.

Parameter Type Description
dates Date[] Collection of dates on which the given start and end hour range needs to be applied.
start string Defines the work start hour.
end string Defines the work end hour.
groupIndex (optional) number Defines the resource index from last level.

Returns void

showSpinner

Allows to show the spinner on schedule at the required scenarios.

Returns void

Events

actionBegin

EmitType<ActionEventArgs>

Triggers on beginning of every scheduler action.

actionComplete

EmitType<ActionEventArgs>

Triggers on successful completion of the scheduler actions.

actionFailure

EmitType<ActionEventArgs>

Triggers when a scheduler action gets failed or interrupted and an error information will be returned.

beforePaste

EmitType<BeforePasteEventArgs>

Triggers once when pasting an event on the scheduler.

beforePrint

EmitType<BeforePrintEventArgs>

Triggers when the print event is called.

cellClick

EmitType<CellClickEventArgs>

Triggers when the scheduler cells are single clicked or on single tap on the same cells in mobile devices.

cellDoubleClick

EmitType<CellClickEventArgs>

Triggers when the scheduler cells are double clicked.

created

EmitType<Record>

Triggers after the scheduler component is created.

dataBinding

EmitType<ReturnType>

Triggers before the data binds to the scheduler.

dataBound

EmitType<ReturnType>

Triggers once the event data is bound to the scheduler.

destroyed

EmitType<Record>

Triggers when the scheduler component is destroyed.

drag

EmitType<DragEventArgs>

Triggers when an appointment is being in a dragged state.

dragStart

EmitType<DragEventArgs>

Triggers when an appointment is started to drag.

dragStop

EmitType<DragEventArgs>

Triggers when the dragging of appointment is stopped.

eventClick

EmitType<EventClickArgs>

Triggers when the events are single clicked or on single tapping the events on the mobile devices.

eventDoubleClick

EmitType<EventClickArgs>

Triggers when the events are double clicked or on double tapping the events on the desktop devices.

eventRendered

EmitType<EventRenderedArgs>

Triggers before each of the event getting rendered on the scheduler user interface.

excelExport

EmitType<ExcelExportEventArgs>

Triggers before the Excel export process begins.

hover

EmitType<HoverEventArgs>

Triggers when the scheduler elements are hovered.

moreEventsClick

EmitType<MoreEventsClickArgs>

Triggers when the more events indicator are clicked.

Triggers before the date or view navigation takes place on scheduler.

popupClose

EmitType<PopupCloseEventArgs>

Triggers before any of the scheduler popups close on the page.

popupOpen

EmitType<PopupOpenEventArgs>

Triggers before any of the scheduler popups opens on the page.

renderCell

EmitType<RenderCellEventArgs>

Triggers before each element of the schedule rendering on the page.

resizeStart

EmitType<ResizeEventArgs>

Triggers when an appointment is started to resize.

resizeStop

EmitType<ResizeEventArgs>

Triggers when the resizing of appointment is stopped.

resizing

EmitType<ResizeEventArgs>

Triggers when an appointment is being in a resizing action.

select

EmitType<SelectEventArgs>

Triggers when multiple cells or events are selected on the Scheduler.

tooltipOpen

EmitType<TooltipOpenEventArgs>

Triggers before the tooltip is rendered.

virtualScrollStart

EmitType<ScrollEventArgs>

Triggers when the scroll action is started. This event triggers only when allowVirtualScrolling or enableLazyLoading properties are enabled along with resource grouping.

virtualScrollStop

EmitType<ScrollEventArgs>

Triggers when the scroll action is stopped. This event triggers only when allowVirtualScrolling or enableLazyLoading properties are enabled along with resource grouping.

Contents
Contents